/*
 *  CPUID MP
 *
 */
 
#define NAME "Test"
#define TITLE " Roy Longbottom's CPU ID Program "
#define INITGUID

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <xmmintrin.h>
#include <emmintrin.h>
#include <time.h>
#include "asmtime.h"
#include "CpuIDMP.h"

//  ************** PROTOPTYPES *****************

BOOL FAR PASCAL AboutDlgProc( HWND, UINT, WPARAM, LPARAM);
BOOL InitApp(HINSTANCE, LPSTR, int);
LRESULT CALLBACK  WindowProc(HWND, UINT, WPARAM, LPARAM);                  
static void CleanUpAndPostQuit(void);
static BOOL GetFileName();
void displayWhatever(HWND);

BOOL  FAR PASCAL TestPanel( HWND, UINT, WPARAM, LPARAM);
BOOL  runAllTests();
void local_time();
BOOL saveData();
BOOL StartThread1();
BOOL StartThread2();
BOOL StartThread3();
DWORD WINAPI CountLoop1(LPVOID inParam1);
DWORD WINAPI CountLoop2(LPVOID inParam1);
DWORD WINAPI CountLoop3(LPVOID inParam1);
BOOL WINAPI RunThread1();
BOOL WINAPI RunThread2();
BOOL WINAPI RunThread3();
void intTest1();
void intTest2();
void floatTest1();

// ************* GLOBAL VARIABLES **********

char   currentDir[MAX_PATH];

unsigned int icount;
unsigned int icount2;
unsigned int intCount;
unsigned int intCount2;
float  * ssum1;
float  * ssum11;
float  * save1;
float  * save11;

// char   version[30] = "32 bit Version 1.0";
char   version[30] = "64 bit Version 1.0";
// char   assembler[70] = "    Assembled with Microsoft ml.exe Version 6.15.8803";
char   assembler[70] = " Assembled with Microsoft ml64.exe Version 8.00.40310.39";

BOOL bQuit = FALSE;

HWND   mainHWND;
HWND   paramHwnd = NULL;
HINSTANCE  MyInstance;

char    timeday[30];

char    writeMsg[200];
char    windowText[256];
char    commandLine[1024] = "";

int  runStage = -2;

int  mips1Pass[4];
int  mflops1Pass[4];
int  mips2Pass[4];
int  mflops2Pass[4];
int  mips3Pass[4];
int  mflops3Pass[4];
int  mips4Pass[4];
int  mflops4Pass[4];

BOOL  autoRun = FALSE;

char fileName[256] = "CPUInfo.txt";

HANDLE hThreadHandle1;
HANDLE hThreadHandle2;
HANDLE hThreadHandle3;
LPVOID inputParam1;
LPVOID inputParam2;
LPVOID inputParam3;
BOOL  goThread1;
BOOL  goThread2;
BOOL  goThread3;
BOOL  dataSaved = FALSE;
volatile double  threadCount1;
volatile double  threadCount0;
volatile double  threadCount2;
volatile double  threadCount3;

BOOL StartThread1()
{
    DWORD dwThreadId1;

    hThreadHandle1 = CreateThread(
                        NULL,
                        0,
                        CountLoop1,
                        inputParam1,
                        0,
                        &dwThreadId1
                        );
    if ( hThreadHandle1 == NULL ) 
    {
        return FALSE;
    }   
   return TRUE;
}

BOOL StartThread2()
{
    DWORD dwThreadId2;

    hThreadHandle2 = CreateThread(
                        NULL,
                        0,
                        CountLoop2,
                        inputParam2,
                        0,
                        &dwThreadId2
                        );
    if ( hThreadHandle2 == NULL ) 
    {
        return FALSE;
    }   
   return TRUE;
}

BOOL StartThread3()
{
    DWORD dwThreadId3;

    hThreadHandle3 = CreateThread(
                        NULL,
                        0,
                        CountLoop3,
                        inputParam3,
                        0,
                        &dwThreadId3
                        );
    if ( hThreadHandle3 == NULL ) 
    {
        return FALSE;
    }   
   return TRUE;
}

DWORD WINAPI CountLoop1(LPVOID inParam1)
{
    BOOL threadNeeded1 = TRUE;
    inParam1 = inParam1;
    
    while (threadNeeded1)
    {
        if (RunThread1()) threadNeeded1 = FALSE;
        // FALSE only when Windows closes
    }
    return 0;
}

DWORD WINAPI CountLoop2(LPVOID inParam2)
{
    BOOL threadNeeded2 = TRUE;
    inParam2 = inParam2;
    
    while (threadNeeded2)
    {
        if (RunThread2()) threadNeeded2 = FALSE;
        // FALSE only when Windows closes
    }
    return 0;
}

DWORD WINAPI CountLoop3(LPVOID inParam3)
{
    BOOL threadNeeded3 = TRUE;
    inParam3 = inParam3;
    
    while (threadNeeded3)
    {
        if (RunThread3()) threadNeeded3 = FALSE;
        // FALSE only when Windows closes
    }
    return 0;
}

BOOL WINAPI RunThread1()
{
    intTest1(); 
    if (!goThread1) 
    {
        return TRUE;
    }
    return FALSE; // exit here until Windows closes
}

BOOL WINAPI RunThread2()
{
    floatTest1(); 
    if (!goThread2) 
    {
        return TRUE;
    }
    return FALSE; // exit here until Windows closes
}

BOOL WINAPI RunThread3()
{
    intTest2(); 
    if (!goThread3) 
    {
        return TRUE;
    }
    return FALSE; // exit here until Windows closes
}

void intTest1()
{
    icount = 1;
    mips4Reg();
    threadCount1 = threadCount1 + 1.0;
}

void floatTest1()
{
    if (hasSSE)
    {
       ssum11[4] = 1;
       ssum11[5] = 1;
       ssum11[6] = 1;
       ssum11[7] = 1;
       ssum11[0] = 0;
       ssum11[1] = 0;
       ssum11[2] = 0;
       ssum11[3] = 0;
       SSE4Reg2();
    }
    threadCount2 = threadCount2 + 1.0;
}

void intTest2()
{
    icount2 = 1;
    mips4Reg2();
    threadCount3 = threadCount3 + 1.0;
}

void displayWhatever(HWND hwnd)
{
    if (paramHwnd)   DestroyWindow(paramHwnd);
    sprintf(windowText, " Roy Longbottom's Multi-Thread 64 bit CPU ID and Speed Test");
    SetWindowText(mainHWND, windowText);        
    paramHwnd = CreateDialog( MyInstance,"TEST_PANEL", hwnd, (DLGPROC)TestPanel);
          
} // displayWhatever

/*
 * WinMain - initialization, message loop
 */
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR cmdline, int cmdshow)
{
    MSG         msg;
    
    hPrevInstance = hPrevInstance;

    if (!InitApp(hInstance, cmdline, cmdshow))
         return FALSE;

    GetMessage( &msg, NULL, 0, 0 );
    if (!runAllTests())
    {
       CleanUpAndPostQuit();
    }
    else
    {
         displayWhatever(mainHWND);
    }
    if (autoRun)
    {
       if (!bQuit)
       {
          if (paramHwnd) DestroyWindow(paramHwnd);            
          saveData();
          CleanUpAndPostQuit();
       }
    }
    while(!bQuit)
    {
        if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
        {     
           if (msg.message == WM_QUIT)
           {
                CleanUpAndPostQuit();
                break;
           }
   
           if( !GetMessage( &msg, NULL, 0, 0 ) ) return ((int)msg.wParam);
           TranslateMessage(&msg);
           DispatchMessage(&msg);
        }
        else
        {
           // make sure we go to sleep if we have nothing else to do
           WaitMessage();
        }
    }
    return ((int) msg.wParam);
    
} /* WinMain */

/****************************************************************************/
/*                   Initialization and object creation                     */
/****************************************************************************/
/*
 * InitApp
 * Creates window
 */
BOOL
InitApp(HINSTANCE hInstance, LPSTR cmdline, int cmdshow)
{
    HWND hwnd;
    WNDCLASS wc;
    int   i, j;
    char *delims = {" ,"};
    char commands[20][256];
    char *p;
    char buf[256] = "";
  
    /*
     * set up and registers the window class
     */
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = sizeof(DWORD);
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, "GenericIcon");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = "GenericMenu";
    wc.lpszClassName = NAME;
    if (!RegisterClass(&wc))
        return FALSE;

    /*
     * Create the window
     */

    hwnd =
        CreateWindow(
            NAME,
            TITLE,
            WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL,
            0,
            0,
            640,
            480,
            NULL, 
            NULL, 
            hInstance, 
            NULL 
        );

    if (!hwnd) return FALSE;

    mainHWND = hwnd;
    strcpy(commandLine, strupr(cmdline));
   
    getDetails();
    
    i = 0;
    p = strtok(commandLine, delims);
    while (p != NULL)
    {
        strcpy(commands[i], p);
        strcat(buf, commands[i]);
        strcat(buf, " ");
        i = i + 1;
        if (i > 8) break;
        p = strtok(NULL, delims);
    }
    if (i > 0)
    {
        strcpy(commandLine, buf);
    }
    else
    {
        strcpy(commandLine, "None");
    }
    autoRun = FALSE;
    for (j=0; j<i; j++)
    {
        switch(commands[j][0])
        {            
            case 'A': // Auto Run
             autoRun = TRUE;
             break;            


            case 'L': // log file
             if (j < i -1)
             {
                 sscanf(commands[j+1], "%s", fileName);
             }
             break;
        }
    }

    // Display the window
    GetCurrentDirectory(MAX_PATH, currentDir);

    ShowWindow(hwnd, cmdshow);    
    UpdateWindow(hwnd);

    displayWhatever(mainHWND);
    
    return TRUE;
    
}  // InitApp


/*
 * WindowProc - handle messages for the main application window
 */

LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg,
                            WPARAM wparam, LPARAM lparam)                  
{
    BOOL doSave = FALSE;
       
    switch( msg )
    {
    case WM_ACTIVATEAPP:
        break;
        
    case WM_INITMENUPOPUP:
        break;
        
    case WM_CREATE:
        break;

    case WM_DESTROY:
        CleanUpAndPostQuit();
        break;

    case WM_COMMAND:
        switch( LOWORD( wparam ) )
        {
        case MENU_ABOUT:
            DialogBox( MyInstance,"AboutBox", hwnd, (DLGPROC)AboutDlgProc );
            break;

       case MENU_RUNALL:
            if (!runAllTests()) CleanUpAndPostQuit();
            displayWhatever(mainHWND);                                     
            break;

       case MENU_SAVE:
            if (paramHwnd)   DestroyWindow(paramHwnd);            
            if( GetFileName())
            {
               saveData();
               SetCurrentDirectory(currentDir);
            }
            displayWhatever(mainHWND);
            break;

        case MENU_EXIT:
            if (!dataSaved)
            {
                 if (MessageBox(NULL, "Save last results ?", "Last Results Not Saved",
                 MB_ICONQUESTION | MB_YESNO) == IDYES) doSave = TRUE;
            }
            if (doSave)
            {
                if( GetFileName())
                {
                   saveData();
                   SetCurrentDirectory(currentDir);
                }
            }
            CleanUpAndPostQuit();
            break;
                
        }
        break;
   
        case WM_PAINT:
             break;
           
        case WM_KEYDOWN:
            break;

       case WM_ACTIVATE:
            break;
    } 
    return (DefWindowProc( hwnd, msg, wparam, lparam ));

} /* WindowProc */



/*
 * AboutDlgProc - processes messages for the about dialog.
 */
BOOL FAR PASCAL AboutDlgProc( HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam )
{
    lparam = lparam;

    switch( msg ) {
    case WM_INITDIALOG:
        return( TRUE );

    case WM_COMMAND:
        if( LOWORD( wparam ) == IDOK ) {
            EndDialog( hwnd, TRUE );
            return( TRUE );
        }
        break;
    }
    return( FALSE );

} /* AboutDlgProc */



  
void local_time()
{

    time_t time_of_day;
    time_of_day = time( NULL ); 
    strcpy (timeday, ctime(&time_of_day)); // timeday = date and time
    return;
}



/*
 * CleanUpAndPostQuit
 * Release all D3DRM objects, post a quit message and set the bQuit flag
 */
void
CleanUpAndPostQuit(void)
{
    bQuit = TRUE;
    return;
}


BOOL FAR PASCAL TestPanel( HWND hdlg, UINT msg,
                                WPARAM wparam, LPARAM lparam )
{
    wparam = wparam;
    lparam = lparam;
    char     tab = 9;
    char   lineSpace[2] = " ";
//    int FAR  tabs[4] = {75, 115, 155, 190}; // 215
    int FAR  tabs[4] = {74, 112, 150, 185}; // 215
    hdlg = hdlg;

     switch( msg )
     {
       case WM_INITDIALOG:

        SendDlgItemMessage(hdlg, DATA_LIST, LB_SETTABSTOPS, (WPARAM) 4,
                                                 (LPARAM) (int FAR*) tabs);
        SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) configdata[1]);
        SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) configdata[2]);
        SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) configdata[3]);
        SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) configdata[5]);
        SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) configdata[6]);
        SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) configdata[7]);
        SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) configdata[8]);
        if (runStage == -1)
        {
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0,
                            (LPARAM) lineSpace);
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0,
                (LPARAM) " Floating Point Test Running");
        }
        if (runStage > -1)
        {
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) lineSpace);
            sprintf(writeMsg, " Register add speed  %c --Pass1--- %c---Pass2---"
                              " %c---Pass3--- %c ", tab, tab, tab, tab); 
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);

            if (hasSSE)
            {
                sprintf(writeMsg, " 32 bit SSE MFLOPS %c%8d %c%8d %c%8d %c%s",
                    tab, mflops1Pass[0], tab, mflops1Pass[1], tab, mflops1Pass[2], tab, "Separate test");    
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            }
            if (runStage == 0)
            {
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0,
                                (LPARAM) lineSpace);
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0,
                    (LPARAM) " Integer Test Running");
            }
        }
        if (runStage > 0)
        {
            sprintf(writeMsg, " 32 bit Integer MIPS %c%8d %c%8d %c%8d %c%s",
                tab, mips1Pass[0], tab, mips1Pass[1], tab, mips1Pass[2], tab, "Separate test");    
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);

            if (runStage == 1)
            {
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0,
                                (LPARAM) lineSpace);
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0,
                    (LPARAM) " Two Thread Test Running");
            }
        }
        if (runStage > 1)
        {
            if (hasSSE)
            {
                sprintf(writeMsg, " 32 bit SSE MFLOPS %c%8d %c%8d %c%8d %c%s",
                    tab, mflops2Pass[0], tab, mflops2Pass[1], tab, mflops2Pass[2], tab, "Thread a1 Same Priority");    
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            }
            sprintf(writeMsg, " 32 bit Integer MIPS %c%8d %c%8d %c%8d %c%s",
                tab, mips2Pass[0], tab, mips2Pass[1], tab, mips2Pass[2], tab, "Thread a2 Same Priority");    
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            if (runStage == 2)
            {
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0,
                                (LPARAM) lineSpace);
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0,
                    (LPARAM) " Four Thread Test Running");
            }
        }
        if (runStage > 2)
        {
            if (hasSSE)
            {
                sprintf(writeMsg, " 32 bit SSE MFLOPS %c%8d %c%8d %c%8d %c%s",
                    tab, mflops3Pass[0], tab, mflops3Pass[1], tab, mflops3Pass[2], tab, "Thread b1 Priority Norm");    
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            }
            sprintf(writeMsg, " 32 bit Integer MIPS %c%8d %c%8d %c%8d %c%s",
                tab, mips3Pass[0], tab, mips3Pass[1], tab, mips3Pass[2], tab, "Thread b2 Priority Norm-1");    
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            if (hasSSE)
            {
                sprintf(writeMsg, " 32 bit SSE MFLOPS %c%8d %c%8d %c%8d %c%s",
                    tab, mflops4Pass[0], tab, mflops4Pass[1], tab, mflops4Pass[2], tab, "Thread b3 Priority Norm-1");    
                SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            }
            sprintf(writeMsg, " 32 bit Integer MIPS %c%8d %c%8d %c%8d %c%s",
                tab, mips4Pass[0], tab, mips4Pass[1], tab, mips4Pass[2], tab, "Thread b4 Priority Norm-1");
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);
        }
        if (runStage > 9)
        {
//            sprintf(writeMsg, " Thread Count       %c%8d %c%8d %c%8d %c%d",
//                tab, (int)threadCount1, tab, (int)threadCount0, tab, (int)threadCount2, tab, (int)threadCount3);    
//            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) lineSpace);
            SendDlgItemMessage(hdlg, DATA_LIST, LB_ADDSTRING, 0, (LPARAM) " Test Finished");
            SendDlgItemMessage(hdlg, DATA_LIST, LB_SETCURSEL, 17, 0L);
        }

        return( TRUE );
                    
       case WM_COMMAND:
 
        if( HIWORD( wparam ) == LBN_SELCHANGE)
        {
             displayWhatever(mainHWND);
        }
        else if( HIWORD( wparam ) == BN_CLICKED)
        {
            switch (LOWORD (wparam))
            {
                case RUN_ALL:
                 PostMessage(mainHWND, WM_COMMAND, MENU_RUNALL, 0);
                 break;

                case SAVE:
                 PostMessage(mainHWND, WM_COMMAND, MENU_SAVE, 0);
                 break;

                case EXIT_BUTTON:
                 PostMessage(mainHWND, WM_COMMAND, MENU_EXIT, 0);
                 break;
            }
            displayWhatever(mainHWND);
        }

        return( TRUE );         
     }
     return( FALSE );
    
} // TestPanel


BOOL  runAllTests()
{
   int i, j;
   int LOWER_PRIORITY;
   double         totalS1  = 8000000;
   double         totalI1  = 2200000;

   dataSaved = FALSE;
   ssum1 = (float *)_aligned_malloc(64, 16);
   if (ssum1 == NULL)
   {
        sprintf(writeMsg, "Cannot allocate memory");
        if (!autoRun) MessageBox(NULL, writeMsg, "ERROR WILL EXIT", MB_ICONWARNING | MB_OK);
        CleanUpAndPostQuit();
        return FALSE;
   }        
   ssum11 = (float *)_aligned_malloc(64, 16);
   if (ssum11 == NULL)
   {
        sprintf(writeMsg, "Cannot allocate memory");
        if (!autoRun) MessageBox(NULL, writeMsg, "ERROR WILL EXIT", MB_ICONWARNING | MB_OK);
        _aligned_free(ssum1);
        CleanUpAndPostQuit();
        return FALSE;
   }        
   save1 = (float *)_aligned_malloc(64, 16);
   if (save1 == NULL)
   {
        sprintf(writeMsg, "Cannot allocate memory");
        if (!autoRun) MessageBox(NULL, writeMsg, "ERROR WILL EXIT", MB_ICONWARNING | MB_OK);
        _aligned_free(ssum11);
        _aligned_free(ssum1);
        CleanUpAndPostQuit();
        return FALSE;
   }        
   save11 = (float *)_aligned_malloc(64, 16);
   if (save11 == NULL)
   {
        sprintf(writeMsg, "Cannot allocate memory");
        if (!autoRun) MessageBox(NULL, writeMsg, "ERROR WILL EXIT", MB_ICONWARNING | MB_OK);
        _aligned_free(save1);
        _aligned_free(ssum11);
        _aligned_free(ssum1);
        CleanUpAndPostQuit();
        return FALSE;
   }        

   local_time();

   runStage = -1;
   displayWhatever(mainHWND);

   if (hasSSE)
   {
       for (j=0; j<3; j++)
       {
           mflops1Pass[j] = 0;
           threadCount0 = 0;
           start_time();
           do
           {
               ssum1[4] = 1;
               ssum1[5] = 1;
               ssum1[6] = 1;
               ssum1[7] = 1;
               for (i=0; i<10; i++)
               {    
                   ssum1[0] = 0;
                   ssum1[1] = 0;
                   ssum1[2] = 0;
                   ssum1[3] = 0;
                   SSE4Reg();
               }
               threadCount0 = threadCount0 + 10.0;
               end_time();
           }
           while (secs < 1.0);
           mflops1Pass[j] = (int)(totalS1 * threadCount0 / 1000000.0 / secs + 0.5);
       }
   }

   runStage = 0;
   displayWhatever(mainHWND);

   for (j=0; j<3; j++)
   {
       mips1Pass[j] = 0;
       threadCount1 = 0;
       icount = 1;
       start_time();
       do
       {
           for (i=0; i<10; i++)
           {    
               mips4Reg();
           }
           threadCount1 = threadCount1 + 10;
           icount = 1;
           end_time();
       }
       while (secs < 1.0);
       mips1Pass[j] = (int)((totalI1 * threadCount1) / 1000000.0 / secs + 0.5);
   }
   runStage = 1;
   displayWhatever(mainHWND);

   goThread1 = TRUE;
   StartThread1();    
   SetThreadPriority(hThreadHandle1, THREAD_PRIORITY_NORMAL);
   SuspendThread(hThreadHandle1);
   goThread2 = TRUE;
   StartThread2();    
   SetThreadPriority(hThreadHandle2, THREAD_PRIORITY_NORMAL);
   SuspendThread(hThreadHandle2);
   goThread3 = TRUE;
   StartThread3();    
   SetThreadPriority(hThreadHandle3, THREAD_PRIORITY_NORMAL);
   SuspendThread(hThreadHandle3);
   LOWER_PRIORITY = THREAD_PRIORITY_BELOW_NORMAL;

   if (hasSSE)
   {
       for (j=0; j<3; j++)
       {
           mflops2Pass[j] = 0;
           mips2Pass[j] = 0;
           ResumeThread(hThreadHandle1);
           SetThreadPriority(hThreadHandle1, THREAD_PRIORITY_NORMAL);
           threadCount1 = 0;
           threadCount0 = 0;
           start_time();
           do
           {
               ssum1[4] = 1;
               ssum1[5] = 1;
               ssum1[6] = 1;
               ssum1[7] = 1;
               for (i=0; i<10; i++)
               {    
                   ssum1[0] = 0;
                   ssum1[1] = 0;
                   ssum1[2] = 0;
                   ssum1[3] = 0;
                   SSE4Reg();
               }
               threadCount0 = threadCount0 + 10.0;
               end_time();
           }
           while (secs < 1.0);
           SuspendThread(hThreadHandle1);       
           mflops2Pass[j] = (int)(totalS1 * threadCount0 / 1000000.0 / secs + 0.5);
           mips2Pass[j]   = (int)(totalI1 * threadCount1 / 1000000.0 / secs + 0.5);
       }
   }
   runStage = 2;
   displayWhatever(mainHWND);

   if (hasSSE)
   {
       for (j=0; j<3; j++)
       {
           mflops3Pass[j] = 0;
           mips3Pass[j] = 0;
           ResumeThread(hThreadHandle1);
           SetThreadPriority(hThreadHandle1, LOWER_PRIORITY);
           ResumeThread(hThreadHandle2);
           SetThreadPriority(hThreadHandle2, LOWER_PRIORITY);
           ResumeThread(hThreadHandle3);
           SetThreadPriority(hThreadHandle3, LOWER_PRIORITY);
           threadCount1 = 0;
           threadCount0 = 0;
           threadCount2 = 0;
           threadCount3 = 0;
           start_time();
           do
           {
               ssum1[4] = 1;
               ssum1[5] = 1;
               ssum1[6] = 1;
               ssum1[7] = 1;
               for (i=0; i<10; i++)
               {    
                   ssum1[0] = 0;
                   ssum1[1] = 0;
                   ssum1[2] = 0;
                   ssum1[3] = 0;
                   SSE4Reg();
               }
               threadCount0 = threadCount0 + 10.0;
               end_time();
           }
           while (secs < 1.0);
           SuspendThread(hThreadHandle1);       
           SuspendThread(hThreadHandle2);       
           SuspendThread(hThreadHandle3);       
           mflops3Pass[j] = (int)(totalS1 * threadCount0 / 1000000.0 / secs + 0.5);
           mips3Pass[j]   = (int)(totalI1 * threadCount1 / 1000000.0 / secs + 0.5);
           mflops4Pass[j] = (int)(totalS1 * threadCount2 / 1000000.0 / secs + 0.5);
           mips4Pass[j]   = (int)(totalI1 * threadCount3 / 1000000.0 / secs + 0.5);
       }
   }
   runStage = 3;
   displayWhatever(mainHWND);

   ResumeThread(hThreadHandle1);
   goThread1 = FALSE;
   CloseHandle( hThreadHandle1 );
   ResumeThread(hThreadHandle2);
   goThread2 = FALSE;
   CloseHandle( hThreadHandle2 );
   ResumeThread(hThreadHandle3);
   goThread3 = FALSE;
   CloseHandle( hThreadHandle3 );
   _aligned_free(save11);
   _aligned_free(save1);
   _aligned_free(ssum11);
   _aligned_free(ssum1);
   runStage = 10;
   displayWhatever(mainHWND);
   return TRUE;

} // runAllTests

static BOOL GetFileName()
{
    static char    filterList[] = "File (*.*)" \
                                        "\0" \
                                        "*.*" \
                                        "\0\0";
    OPENFILENAME        of;
    int                 rc;
    
    memset( &of, 0, sizeof( OPENFILENAME ) );
    of.lStructSize = sizeof( OPENFILENAME );
    of.hwndOwner = mainHWND;
    of.lpstrFilter = (LPSTR) filterList;
    of.lpstrDefExt = "";
    of.nFilterIndex = 1L;
    of.lpstrFile = fileName;
    of.nMaxFile = _MAX_PATH;
    of.lpstrTitle = NULL;
    of.lpstrInitialDir = currentDir;
    of.Flags = OFN_HIDEREADONLY;

    rc = GetSaveFileName( &of );
    strcpy(fileName, of.lpstrFile);
   
    return( rc );
    
} // GetFileName

BOOL saveData()
{
     FILE *outfile;
     int i;

     outfile = fopen(fileName,"a+");
     if (outfile == NULL)
     {
         MessageBox(NULL, "Cannot open log file", fileName,
                                 MB_ICONWARNING | MB_OK);
         return FALSE;
     }
     fprintf (outfile, "\n\n #####################################################################\n");
     fprintf (outfile, "   CPU ID and MP Speed Test %s %s \n", version, timeday);
     fprintf (outfile, "      %s\n\n", assembler);
     fprintf (outfile, "                    Copyright Roy Longbottom 2005\n\n");

     for (i=0; i<9; i++)
     {
         fprintf(outfile, "%s\n", configdata[i]);
     }
     fprintf(outfile,"\n");

     fprintf(outfile, "  Speed adding to registers   Pass 1   Pass 2   Pass 3\n\n");
     fprintf(outfile, "  Separate Tests\n");
     if (hasSSE)
     {
         fprintf(outfile, "  32 bit SSE   MFLOPS      %8d %8d %8d\n", mflops1Pass[0], mflops1Pass[1], mflops1Pass[2]);
     }
     fprintf(outfile, "  32 bit Integer MIPS      %8d %8d %8d\n", mips1Pass[0], mips1Pass[1], mips1Pass[2]);    
     fprintf(outfile, "\n");

     fprintf(outfile, "  Two Threads Equal Priority\n");
     if (hasSSE)
     {
         fprintf(outfile, "  32 bit SSE   MFLOPS      %8d %8d %8d\n", mflops2Pass[0], mflops2Pass[1], mflops2Pass[2]);
     }
     fprintf(outfile, "  32 bit Integer MIPS      %8d %8d %8d\n", mips2Pass[0], mips2Pass[1], mips2Pass[2]);
     fprintf(outfile, "\n");

     fprintf(outfile, "  Four Threads, First Normal Priority, Others Normal - 1\n");
     if (hasSSE)
     {
         fprintf(outfile, "  32 bit SSE   MFLOPS      %8d %8d %8d\n", mflops3Pass[0], mflops3Pass[1], mflops3Pass[2]);   
     }
     fprintf(outfile, "  32 bit Integer MIPS      %8d %8d %8d\n", mips3Pass[0], mips3Pass[1], mips3Pass[2]);    
     if (hasSSE)
     {
         fprintf(outfile, "  32 bit SSE   MFLOPS      %8d %8d %8d\n", mflops4Pass[0], mflops4Pass[1], mflops4Pass[2]);   
     }
     fprintf(outfile, "  32 bit Integer MIPS      %8d %8d %8d\n", mips4Pass[0], mips4Pass[1], mips4Pass[2]);    

     fprintf(outfile, "\n");
     fflush (outfile);
     fclose(outfile);  
     dataSaved = TRUE;
     return TRUE;
}


