/* 
 * RandMP Benchmark Version 1.1 Copyright (c) Roy Longbottom 2005 
 *
 *
 */
 
#define NAME "Test"
#define TITLE " RandMP Memory Test"
#define INITGUID

#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <time.h>
#include <math.h>
#include <xmmintrin.h>
#include <emmintrin.h>
#include <mmsystem.h>
#include "RandMP.h"
#include "asmtime.h"


//  ************** PROTOPTYPES *****************

BOOL FAR PASCAL AboutDlgProc( HWND, UINT, WPARAM, LPARAM);
static BOOL InitApp(HINSTANCE, LPSTR, int);
LRESULT CALLBACK WindowProc(HWND, UINT, WPARAM, LPARAM);                  
static void CleanUpAndPostQuit(void);
void displayWhatever(HWND);

BOOL FAR PASCAL TestPanel( HWND, UINT, WPARAM, LPARAM);
BOOL FAR PASCAL RunPanel( HWND, UINT, WPARAM, LPARAM);

void local_time();

BOOL runTests();
void calibrate(int i);

void   thread1TestRW();
void   thread2TestRW();
void   thread1TestRD();
void   thread2TestRD();

DWORD WINAPI threadTest1RW (LPVOID inParam1);
DWORD WINAPI threadTest2RW (LPVOID inParam2);
DWORD WINAPI threadTest1RD (LPVOID inParam1);
DWORD WINAPI threadTest2RD (LPVOID inParam2);

// ************* GLOBAL VARIABLES **********
 
int    * xi;

// char   version[30] = "32 bit Version 1.1";
char   version[30] = "64 bit Version 1.1";
// char   compiler[80] = " Via Microsoft 32-bit C/C++ Optimizing Compiler Version 13.10.3077 for 80x86";
char   compiler[80] = " Via Microsoft C/C++ Optimizing Compiler Version 14.00.40310.41 for AMD64";
// char    windowText[256] = " Roy Longbottom's 32 bit Multi-Thread Serial/Random MemorySpeed Test";
char    windowText[256]  = " Roy Longbottom's 64 bit Multi-Thread Serial/Random Memory Speed Test";

char    mips[256] = "           For approximate speed in MIPS divide MBytes/Second by 3.2";

double results[10][15];
double runmsecs[10][15];
DWORD   mmmsecs[10][15];
volatile DWORD   mmtime0;
volatile DWORD   mmtime1;
volatile DWORD   mmtime2;
char   mslabel[15][20];

BOOL  debug = FALSE;

int           memoryWords[20];
unsigned int memoryBytes[20];
unsigned int wordBytes = 4;
int ipass;
double kcount;
double wordsTested;
double wordsTested2;

volatile int threadCount1;
volatile int startWords;
volatile int endWords;
volatile int incWords;
volatile int extraLoops;
int theseWords;

volatile int threadCount2;
volatile int startWords2;
volatile int endWords2;
volatile int incWords2;
volatile int extraLoops2;
volatile int memoryWdsi;
int theseWords2;

int theseWordsSR[10];
int startWordsSR[10];
int endWordsSR[10];
int incWordsSR[10];
int extraLoopsSR[10];
int tCountSR[10];

int theseWordsSW[10];
int startWordsSW[10];
int endWordsSW[10];
int incWordsSW[10];
int extraLoopsSW[10];
int tCountSW[10];

int theseWordsRR[10];
int startWordsRR[10];
int endWordsRR[10];
int incWordsRR[10];
int extraLoopsRR[10];
int tCountRR[10];

int theseWordsRW[10];
int startWordsRW[10];
int endWordsRW[10];
int incWordsRW[10];
int extraLoopsRW[10];
int tCountRW[10];


int toti1;
volatile int toti2;
HANDLE hThreadHandle1;
HANDLE hThreadHandle2;
HANDLE hSema1;
HANDLE hSema2;
LPVOID inputParam1;
LPVOID inputParam2;
DWORD dwThreadId1;
DWORD dwThreadId2;

BOOL bQuit = FALSE;

HWND   mainHWND;
HWND   testHwnd = NULL;
HWND   runHwnd = NULL;

HINSTANCE  MyInstance;

char    timeday[30];

double   runSecs = 0.5;
volatile double   secs1;
volatile double   secs2;

char   writeMsg[256];
char   dlgMsg1[10][256];
char   addMsg[256];

char    commandLine[1024] = "";

short     keyPress;
int  testRun;
int  extraRun;
BOOL  runDone = FALSE;
BOOL  doTesting = FALSE;
BOOL  autoRun = FALSE;
BOOL  readWrite = FALSE;

DWORD WINAPI threadTest1RW (LPVOID inParam1)
{
    int i;

    inParam1 = inParam1;
    
    WaitForSingleObject(hSema1, 50000);
    for (i=0; i<threadCount1; i++)
    {
        thread1TestRW();
        startWords = startWords + incWords;
        endWords = endWords + incWords;
        if (startWords  >= memoryWdsi)
        {
            startWords = 0;
            endWords = incWords;
        }
    }
    end_time();
    mmtime1 = timeGetTime() - mmtime0;
    secs1 = secs;
    ReleaseSemaphore(hSema2, 1, NULL);
    return 0;
}


DWORD WINAPI threadTest2RW (LPVOID inParam2)
{
    int i;
    
    inParam2 = inParam2;

    WaitForSingleObject(hSema1, 50000);
    for (i=0; i<threadCount2; i++)
    {
        thread2TestRW();
        startWords2 = startWords2 + incWords2;
        endWords2 = endWords2 + incWords2;
        if (startWords2  >= memoryWdsi)
        {
            startWords2 = 0;
            endWords2 = incWords2;
        }
    }
    end_time();
    mmtime2 = timeGetTime() - mmtime0;
    secs2 = secs;
    ReleaseSemaphore(hSema2, 1, NULL);
    return 0;
}

DWORD WINAPI threadTest1RD (LPVOID inParam1)
{
    int i;

    inParam1 = inParam1;
    
    WaitForSingleObject(hSema1, 50000);
    for (i=0; i<threadCount1; i++)
    {
        thread1TestRD();
        startWords = startWords + incWords;
        endWords = endWords + incWords;
        if (startWords  >= memoryWdsi)
        {
            startWords = 0;
            endWords = incWords;
        }
    }
    end_time();
    mmtime1 = timeGetTime() - mmtime0;
    secs1 = secs;
    ReleaseSemaphore(hSema2, 1, NULL);
    return 0;
}

DWORD WINAPI threadTest2RD (LPVOID inParam2)
{
    int i;
    
    inParam2 = inParam2;

    WaitForSingleObject(hSema1, 50000);
    for (i=0; i<threadCount2; i++)
    {
        thread2TestRD();
        startWords2 = startWords2 + incWords2;
        endWords2 = endWords2 + incWords2;
        if (startWords2  >= memoryWdsi)
        {
            startWords2 = 0;
            endWords2 = incWords2;
        }
    }
    end_time();
    mmtime2 = timeGetTime() - mmtime0;
    secs2 = secs;
    ReleaseSemaphore(hSema2, 1, NULL);
    return 0;
}

void displayWhatever(HWND hwnd)
{
    SetWindowText(mainHWND, windowText);        
        
    if (doTesting)
    {
        if (testHwnd)   DestroyWindow(testHwnd);
    }
    else
    {    
        if (runHwnd)    DestroyWindow(runHwnd);
        testHwnd = CreateDialog( MyInstance,"DIALOG_8", hwnd, (DLGPROC)TestPanel);
    }  
} // displayWhatever


// WinMain - initialization, message loop

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR cmdline, int cmdshow)
{
    MSG         msg;
    
    hPrevInstance = hPrevInstance;

    if (!InitApp(hInstance, cmdline, cmdshow))
         return FALSE;

    GetMessage( &msg, NULL, 0, 0 );

    if (autoRun)
    {
         runTests();
         CleanUpAndPostQuit();
    }        
    while(!bQuit)
    {
        if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
        {
            
           if (msg.message == WM_QUIT)
           {
                CleanUpAndPostQuit();
                break;
           }
   
           if( !GetMessage( &msg, NULL, 0, 0 ) ) return (int)msg.wParam;
           TranslateMessage(&msg);
           DispatchMessage(&msg);
        }
        else
        {
           // make sure we go to sleep if we have nothing else to do
           WaitMessage();
        }
    }
    return (int)msg.wParam;
    
} // WinMain

// ***************************************************************************
//                    Initialization and object creation                     *
// ***************************************************************************

// InitApp
// Creates window

static BOOL
InitApp(HINSTANCE hInstance, LPSTR cmdline, int cmdshow)
{
    HWND hwnd;
    WNDCLASS wc;
    int   i, j;
    char *delims = {" ,"};
    char commands[20][256];
    char *p;
    char buf[256] = "";    
  
    
    // set up and registers the window class
    
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = sizeof(DWORD);
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon(hInstance, "GenericIcon");
    wc.hCursor = LoadCursor(NULL, IDC_ARROW);
    wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
    wc.lpszMenuName = "GenericMenu";
    wc.lpszClassName = NAME;
    if (!RegisterClass(&wc))
        return FALSE;

    // Create the window

    hwnd =
        CreateWindow(
            NAME,
            TITLE,
            WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL,
            0,
            0,
            640,
            480,
            NULL, 
            NULL, 
            hInstance, 
            NULL 
        );

    if (!hwnd) return FALSE;

    mainHWND = hwnd;
    strcpy(commandLine, strupr(cmdline));
    getDetails();


    i = 0;
    p = strtok(commandLine, delims);
    while (p != NULL)
    {
        strcpy(commands[i], p);
        strcat(buf, commands[i]);
        strcat(buf, " ");
        i = i + 1;
        if (i > 4) break;
        p = strtok(NULL, delims);
    }
    if (i > 0)
    {
        strcpy(commandLine, buf);
    }
    else
    {
        strcpy(commandLine, "None");
    }
    autoRun = FALSE;

    for (j=0; j<i; j++)
    {
        switch(commands[j][0])
        {            
            case 'A': // Auto Run
             autoRun = TRUE;
             break;  

            case 'D': // Debug
             debug = TRUE;
             break;  
        }
    }
   
    keyPress = GetAsyncKeyState(VK_ESCAPE);

    // Display the window

    SetWindowText(mainHWND, windowText);        
    
    ShowWindow(hwnd, cmdshow);    
    UpdateWindow(hwnd);

    if (!autoRun) displayWhatever(mainHWND);
    
    return TRUE;
    
}  // InitApp



// WindowProc - handle messages for the main application window


LRESULT CALLBACK WindowProc(HWND hwnd, UINT msg,
                            WPARAM wparam, LPARAM lparam)                  
{
           
    switch( msg )
    {
    case WM_ACTIVATEAPP:
        break;
        
    case WM_INITMENUPOPUP:
        break;
        
    case WM_CREATE:
        break;

    case WM_DESTROY:
        CleanUpAndPostQuit();
        break;

    case WM_COMMAND:
        switch( LOWORD( wparam ) )
        {
        case MENU_ABOUT:
            DialogBox( MyInstance,"AboutBox", hwnd, (DLGPROC)AboutDlgProc );
            break;

       case MENU_RUNALL:
            doTesting = TRUE;
            displayWhatever(mainHWND);                                      
            runTests();
            break;


        case MENU_DISPLAY:
            displayWhatever(mainHWND);                                      
            break;
        
        case MENU_EXIT:
            CleanUpAndPostQuit();
            break;
                
        }
        break;
   
        case WM_PAINT:
             break;
           
        case WM_KEYDOWN:
            break;

       case WM_ACTIVATE:
            break;
    } 
    return DefWindowProc( hwnd, msg, wparam, lparam );

} // WindowProc




// AboutDlgProc - processes messages for the about dialog.

BOOL FAR PASCAL AboutDlgProc( HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam )
{
    lparam = lparam;

    switch( msg ) {
    case WM_INITDIALOG:
        return( TRUE );

    case WM_COMMAND:
        if( LOWORD( wparam ) == IDOK ) {
            EndDialog( hwnd, TRUE );
            return( TRUE );
        }
        break;
    }
    return( FALSE );

} // AboutDlgProc



  
void local_time()
{
    time_t time_of_day;
    time_of_day = time( NULL ); 
    strcpy (timeday, ctime(&time_of_day)); // timeday = date and time
    return;
}




// CleanUpAndPostQuit
// Release all D3DRM objects, post a quit message and set the bQuit flag

void
CleanUpAndPostQuit(void)
{
    bQuit = TRUE;
    return;
}


BOOL FAR PASCAL RunPanel( HWND hdlg, UINT msg,
                                WPARAM wparam, LPARAM lparam )
{
    wparam = wparam;
    lparam = lparam;
    int  k;
    hdlg = hdlg;


     switch( msg )
     {
       case WM_INITDIALOG:
        sprintf(writeMsg, "Flashing disk light suggest insufficient RAM and paging activity "
                      "to/from RAM and disk.");
        SendDlgItemMessage(hdlg, NOTES1, LB_ADDSTRING, 0, (LPARAM) writeMsg);
        sprintf(writeMsg, "Press ESC to cancel and exit program. It might take some time.");
        SendDlgItemMessage(hdlg, NOTES1, LB_ADDSTRING, 0, (LPARAM) writeMsg);
       
        if (runDone)
        {            
            sprintf(writeMsg, "%cRandMP Serial/Random Memory Speed Test %s", 9, version);
            SendDlgItemMessage(hdlg, RESULTS1, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            SendDlgItemMessage(hdlg, RESULTS1, LB_ADDSTRING, 0, (LPARAM) "  ");
            sprintf(writeMsg, "   %c %c %c MBytes Per Second At", 9, 9, 9);
            SendDlgItemMessage(hdlg, RESULTS1, LB_ADDSTRING, 0, (LPARAM) writeMsg);

            sprintf(writeMsg, "         %c   6 KB   %c  24 KB %c  96 KB  %c 384 KB %c 768 KB %c1536 KB  %c  12 MB  %c 96 MB",
                                 9, 9, 9, 9, 9, 9, 9, 9);
            SendDlgItemMessage(hdlg, RESULTS1, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            SendDlgItemMessage(hdlg, RESULTS1, LB_ADDSTRING, 0, (LPARAM) " 1 Thread");
            for (k=0; k<extraRun; k++)
            {
               if (k == 4) SendDlgItemMessage(hdlg, RESULTS1, LB_ADDSTRING, 0, (LPARAM) " 2 Threads Total");
               SendDlgItemMessage(hdlg, RESULTS1, LB_ADDSTRING, 0, (LPARAM) dlgMsg1[k]);
            }
        }
        
        return( TRUE );
                    
     }
     return( FALSE );
    
} // runPanel

BOOL FAR PASCAL TestPanel( HWND hdlg, UINT msg,
                                WPARAM wparam, LPARAM lparam )
{
    wparam = wparam;
    lparam = lparam;
    int  k;
    hdlg = hdlg;

     switch( msg )
     {
       case WM_INITDIALOG:
        sprintf(writeMsg, " Click on Run Tests or Exit button.");
        SendDlgItemMessage(hdlg, NOTES, LB_ADDSTRING, 0, (LPARAM) writeMsg);
        sprintf(writeMsg, " After running, results should be in file RandMem.txt and above");
        SendDlgItemMessage(hdlg, NOTES, LB_ADDSTRING, 0, (LPARAM) writeMsg);
      
        if (runDone)
        {
            sprintf(writeMsg, "%cRandMP Serial/Random Memory Speed Test %s", 9, version);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) "  ");
            sprintf(writeMsg, "  %c %c %c MBytes Per Second At", 9, 9, 9);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            sprintf(writeMsg, "         %c   6 KB   %c  24 KB %c  96 KB  %c 384 KB %c 768 KB %c1536 KB  %c  12 MB  %c 96 MB",
                                 9, 9, 9, 9, 9, 9, 9, 9);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg);        
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) " 1 Thread");
            for (k=0; k<extraRun; k++)
            {
               if (k == 4) SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) " 2 Threads Total");
               SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) dlgMsg1[k]);
            }
        }
        else
        {
            sprintf(writeMsg, " RandMP Serial/Random Memory Speed Test %s", version);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) "  ");
            sprintf(writeMsg, " The program uses the same code for serial and random use via a complex");
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            sprintf(writeMsg, " indexing structure and comprises Read (RD) and Read/Write (RW) tests.");
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            sprintf(writeMsg, " They are run to use data from L1 cache, L2 cache and RAM, firstly as a");
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg);
            sprintf(writeMsg, " single thread and secondly using two threads.");
            SendDlgItemMessage(hdlg, RESULTS, LB_ADDSTRING, 0, (LPARAM) writeMsg);
        }
        return( TRUE );
                    
       case WM_COMMAND:

        if( HIWORD( wparam ) == BN_CLICKED)
        {
            switch (LOWORD (wparam))
            {
                case RUN_ALL:
                  PostMessage(mainHWND, WM_COMMAND, MENU_RUNALL, 0);
                 break;

                case EXIT_BUTTON:
                 PostMessage(mainHWND, WM_COMMAND, MENU_EXIT, 0);
                 break;
            }
        }

        return( TRUE );         
     }
     return( FALSE );
    
} // TestPanel

void thread1TestRD()    
{
  int i, j;

  for (j=0; j<extraLoops; j++)
  {
    for (i=startWords; i<endWords; i = i + 512)
    {
      toti1 = toti1
        & xi[xi[i+   0]] | xi[xi[i+   2]]
        & xi[xi[i+   4]] | xi[xi[i+   6]]
        & xi[xi[i+   8]] | xi[xi[i+  10]]
        & xi[xi[i+  12]] | xi[xi[i+  14]]
        & xi[xi[i+  16]] | xi[xi[i+  18]]
        & xi[xi[i+  20]] | xi[xi[i+  22]]
        & xi[xi[i+  24]] | xi[xi[i+  26]]
        & xi[xi[i+  28]] | xi[xi[i+  30]]
        & xi[xi[i+  32]] | xi[xi[i+  34]]
        & xi[xi[i+  36]] | xi[xi[i+  38]]
        & xi[xi[i+  40]] | xi[xi[i+  42]]
        & xi[xi[i+  44]] | xi[xi[i+  46]]
        & xi[xi[i+  48]] | xi[xi[i+  50]]
        & xi[xi[i+  52]] | xi[xi[i+  54]]
        & xi[xi[i+  56]] | xi[xi[i+  58]]
        & xi[xi[i+  60]] | xi[xi[i+  62]]
        & xi[xi[i+  64]] | xi[xi[i+  66]]
        & xi[xi[i+  68]] | xi[xi[i+  70]]
        & xi[xi[i+  72]] | xi[xi[i+  74]]
        & xi[xi[i+  76]] | xi[xi[i+  78]]
        & xi[xi[i+  80]] | xi[xi[i+  82]]
        & xi[xi[i+  84]] | xi[xi[i+  86]]
        & xi[xi[i+  88]] | xi[xi[i+  90]]
        & xi[xi[i+  92]] | xi[xi[i+  94]]
        & xi[xi[i+  96]] | xi[xi[i+  98]]
        & xi[xi[i+ 100]] | xi[xi[i+ 102]]
        & xi[xi[i+ 104]] | xi[xi[i+ 106]]
        & xi[xi[i+ 108]] | xi[xi[i+ 110]]
        & xi[xi[i+ 112]] | xi[xi[i+ 114]]
        & xi[xi[i+ 116]] | xi[xi[i+ 118]]
        & xi[xi[i+ 120]] | xi[xi[i+ 122]]
        & xi[xi[i+ 124]] | xi[xi[i+ 126]]
        & xi[xi[i+ 128]] | xi[xi[i+ 130]]
        & xi[xi[i+ 132]] | xi[xi[i+ 134]]
        & xi[xi[i+ 136]] | xi[xi[i+ 138]]
        & xi[xi[i+ 140]] | xi[xi[i+ 142]]
        & xi[xi[i+ 144]] | xi[xi[i+ 146]]
        & xi[xi[i+ 148]] | xi[xi[i+ 150]]
        & xi[xi[i+ 152]] | xi[xi[i+ 154]]
        & xi[xi[i+ 156]] | xi[xi[i+ 158]]
        & xi[xi[i+ 160]] | xi[xi[i+ 162]]
        & xi[xi[i+ 164]] | xi[xi[i+ 166]]
        & xi[xi[i+ 168]] | xi[xi[i+ 170]]
        & xi[xi[i+ 172]] | xi[xi[i+ 174]]
        & xi[xi[i+ 176]] | xi[xi[i+ 178]]
        & xi[xi[i+ 180]] | xi[xi[i+ 182]]
        & xi[xi[i+ 184]] | xi[xi[i+ 186]]
        & xi[xi[i+ 188]] | xi[xi[i+ 190]]
        & xi[xi[i+ 192]] | xi[xi[i+ 194]]
        & xi[xi[i+ 196]] | xi[xi[i+ 198]]
        & xi[xi[i+ 200]] | xi[xi[i+ 202]]
        & xi[xi[i+ 204]] | xi[xi[i+ 206]]
        & xi[xi[i+ 208]] | xi[xi[i+ 210]]
        & xi[xi[i+ 212]] | xi[xi[i+ 214]]
        & xi[xi[i+ 216]] | xi[xi[i+ 218]]
        & xi[xi[i+ 220]] | xi[xi[i+ 222]]
        & xi[xi[i+ 224]] | xi[xi[i+ 226]]
        & xi[xi[i+ 228]] | xi[xi[i+ 230]]
        & xi[xi[i+ 232]] | xi[xi[i+ 234]]
        & xi[xi[i+ 236]] | xi[xi[i+ 238]]
        & xi[xi[i+ 240]] | xi[xi[i+ 242]]
        & xi[xi[i+ 244]] | xi[xi[i+ 246]]
        & xi[xi[i+ 248]] | xi[xi[i+ 250]]
        & xi[xi[i+ 252]] | xi[xi[i+ 254]]
        & xi[xi[i+ 256]] | xi[xi[i+ 258]]
        & xi[xi[i+ 260]] | xi[xi[i+ 262]]
        & xi[xi[i+ 264]] | xi[xi[i+ 266]]
        & xi[xi[i+ 268]] | xi[xi[i+ 270]]
        & xi[xi[i+ 272]] | xi[xi[i+ 274]]
        & xi[xi[i+ 276]] | xi[xi[i+ 278]]
        & xi[xi[i+ 280]] | xi[xi[i+ 282]]
        & xi[xi[i+ 284]] | xi[xi[i+ 286]]
        & xi[xi[i+ 288]] | xi[xi[i+ 290]]
        & xi[xi[i+ 292]] | xi[xi[i+ 294]]
        & xi[xi[i+ 296]] | xi[xi[i+ 298]]
        & xi[xi[i+ 300]] | xi[xi[i+ 302]]
        & xi[xi[i+ 304]] | xi[xi[i+ 306]]
        & xi[xi[i+ 308]] | xi[xi[i+ 310]]
        & xi[xi[i+ 312]] | xi[xi[i+ 314]]
        & xi[xi[i+ 316]] | xi[xi[i+ 318]]
        & xi[xi[i+ 320]] | xi[xi[i+ 322]]
        & xi[xi[i+ 324]] | xi[xi[i+ 326]]
        & xi[xi[i+ 328]] | xi[xi[i+ 330]]
        & xi[xi[i+ 332]] | xi[xi[i+ 334]]
        & xi[xi[i+ 336]] | xi[xi[i+ 338]]
        & xi[xi[i+ 340]] | xi[xi[i+ 342]]
        & xi[xi[i+ 344]] | xi[xi[i+ 346]]
        & xi[xi[i+ 348]] | xi[xi[i+ 350]]
        & xi[xi[i+ 352]] | xi[xi[i+ 354]]
        & xi[xi[i+ 356]] | xi[xi[i+ 358]]
        & xi[xi[i+ 360]] | xi[xi[i+ 362]]
        & xi[xi[i+ 364]] | xi[xi[i+ 366]]
        & xi[xi[i+ 368]] | xi[xi[i+ 370]]
        & xi[xi[i+ 372]] | xi[xi[i+ 374]]
        & xi[xi[i+ 376]] | xi[xi[i+ 378]]
        & xi[xi[i+ 380]] | xi[xi[i+ 382]]
        & xi[xi[i+ 384]] | xi[xi[i+ 386]]
        & xi[xi[i+ 388]] | xi[xi[i+ 390]]
        & xi[xi[i+ 392]] | xi[xi[i+ 394]]
        & xi[xi[i+ 396]] | xi[xi[i+ 398]]
        & xi[xi[i+ 400]] | xi[xi[i+ 402]]
        & xi[xi[i+ 404]] | xi[xi[i+ 406]]
        & xi[xi[i+ 408]] | xi[xi[i+ 410]]
        & xi[xi[i+ 412]] | xi[xi[i+ 414]]
        & xi[xi[i+ 416]] | xi[xi[i+ 418]]
        & xi[xi[i+ 420]] | xi[xi[i+ 422]]
        & xi[xi[i+ 424]] | xi[xi[i+ 426]]
        & xi[xi[i+ 428]] | xi[xi[i+ 430]]
        & xi[xi[i+ 432]] | xi[xi[i+ 434]]
        & xi[xi[i+ 436]] | xi[xi[i+ 438]]
        & xi[xi[i+ 440]] | xi[xi[i+ 442]]
        & xi[xi[i+ 444]] | xi[xi[i+ 446]]
        & xi[xi[i+ 448]] | xi[xi[i+ 450]]
        & xi[xi[i+ 452]] | xi[xi[i+ 454]]
        & xi[xi[i+ 456]] | xi[xi[i+ 458]]
        & xi[xi[i+ 460]] | xi[xi[i+ 462]]
        & xi[xi[i+ 464]] | xi[xi[i+ 466]]
        & xi[xi[i+ 468]] | xi[xi[i+ 470]]
        & xi[xi[i+ 472]] | xi[xi[i+ 474]]
        & xi[xi[i+ 476]] | xi[xi[i+ 478]]
        & xi[xi[i+ 480]] | xi[xi[i+ 482]]
        & xi[xi[i+ 484]] | xi[xi[i+ 486]]
        & xi[xi[i+ 488]] | xi[xi[i+ 490]]
        & xi[xi[i+ 492]] | xi[xi[i+ 494]]
        & xi[xi[i+ 496]] | xi[xi[i+ 498]]
        & xi[xi[i+ 500]] | xi[xi[i+ 502]]
        & xi[xi[i+ 504]] | xi[xi[i+ 506]]
        & xi[xi[i+ 508]] | xi[xi[i+ 510]];
    }
  }
    return;
}

void thread2TestRD()    
{
  int i, j;

  for (j=0; j<extraLoops2; j++)
  {
    for (i=startWords2; i<endWords2; i = i + 512)
    {
      toti2 = toti2
        & xi[xi[i+ 256]] | xi[xi[i+ 258]]
        & xi[xi[i+ 260]] | xi[xi[i+ 262]]
        & xi[xi[i+ 264]] | xi[xi[i+ 266]]
        & xi[xi[i+ 268]] | xi[xi[i+ 270]]
        & xi[xi[i+ 272]] | xi[xi[i+ 274]]
        & xi[xi[i+ 276]] | xi[xi[i+ 278]]
        & xi[xi[i+ 280]] | xi[xi[i+ 282]]
        & xi[xi[i+ 284]] | xi[xi[i+ 286]]
        & xi[xi[i+ 288]] | xi[xi[i+ 290]]
        & xi[xi[i+ 292]] | xi[xi[i+ 294]]
        & xi[xi[i+ 296]] | xi[xi[i+ 298]]
        & xi[xi[i+ 300]] | xi[xi[i+ 302]]
        & xi[xi[i+ 304]] | xi[xi[i+ 306]]
        & xi[xi[i+ 308]] | xi[xi[i+ 310]]
        & xi[xi[i+ 312]] | xi[xi[i+ 314]]
        & xi[xi[i+ 316]] | xi[xi[i+ 318]]
        & xi[xi[i+ 320]] | xi[xi[i+ 322]]
        & xi[xi[i+ 324]] | xi[xi[i+ 326]]
        & xi[xi[i+ 328]] | xi[xi[i+ 330]]
        & xi[xi[i+ 332]] | xi[xi[i+ 334]]
        & xi[xi[i+ 336]] | xi[xi[i+ 338]]
        & xi[xi[i+ 340]] | xi[xi[i+ 342]]
        & xi[xi[i+ 344]] | xi[xi[i+ 346]]
        & xi[xi[i+ 348]] | xi[xi[i+ 350]]
        & xi[xi[i+ 352]] | xi[xi[i+ 354]]
        & xi[xi[i+ 356]] | xi[xi[i+ 358]]
        & xi[xi[i+ 360]] | xi[xi[i+ 362]]
        & xi[xi[i+ 364]] | xi[xi[i+ 366]]
        & xi[xi[i+ 368]] | xi[xi[i+ 370]]
        & xi[xi[i+ 372]] | xi[xi[i+ 374]]
        & xi[xi[i+ 376]] | xi[xi[i+ 378]]
        & xi[xi[i+ 380]] | xi[xi[i+ 382]]
        & xi[xi[i+ 384]] | xi[xi[i+ 386]]
        & xi[xi[i+ 388]] | xi[xi[i+ 390]]
        & xi[xi[i+ 392]] | xi[xi[i+ 394]]
        & xi[xi[i+ 396]] | xi[xi[i+ 398]]
        & xi[xi[i+ 400]] | xi[xi[i+ 402]]
        & xi[xi[i+ 404]] | xi[xi[i+ 406]]
        & xi[xi[i+ 408]] | xi[xi[i+ 410]]
        & xi[xi[i+ 412]] | xi[xi[i+ 414]]
        & xi[xi[i+ 416]] | xi[xi[i+ 418]]
        & xi[xi[i+ 420]] | xi[xi[i+ 422]]
        & xi[xi[i+ 424]] | xi[xi[i+ 426]]
        & xi[xi[i+ 428]] | xi[xi[i+ 430]]
        & xi[xi[i+ 432]] | xi[xi[i+ 434]]
        & xi[xi[i+ 436]] | xi[xi[i+ 438]]
        & xi[xi[i+ 440]] | xi[xi[i+ 442]]
        & xi[xi[i+ 444]] | xi[xi[i+ 446]]
        & xi[xi[i+ 448]] | xi[xi[i+ 450]]
        & xi[xi[i+ 452]] | xi[xi[i+ 454]]
        & xi[xi[i+ 456]] | xi[xi[i+ 458]]
        & xi[xi[i+ 460]] | xi[xi[i+ 462]]
        & xi[xi[i+ 464]] | xi[xi[i+ 466]]
        & xi[xi[i+ 468]] | xi[xi[i+ 470]]
        & xi[xi[i+ 472]] | xi[xi[i+ 474]]
        & xi[xi[i+ 476]] | xi[xi[i+ 478]]
        & xi[xi[i+ 480]] | xi[xi[i+ 482]]
        & xi[xi[i+ 484]] | xi[xi[i+ 486]]
        & xi[xi[i+ 488]] | xi[xi[i+ 490]]
        & xi[xi[i+ 492]] | xi[xi[i+ 494]]
        & xi[xi[i+ 496]] | xi[xi[i+ 498]]
        & xi[xi[i+ 500]] | xi[xi[i+ 502]]
        & xi[xi[i+ 504]] | xi[xi[i+ 506]]
        & xi[xi[i+ 508]] | xi[xi[i+ 510]]
        & xi[xi[i+   0]] | xi[xi[i+   2]]
        & xi[xi[i+   4]] | xi[xi[i+   6]]
        & xi[xi[i+   8]] | xi[xi[i+  10]]
        & xi[xi[i+  12]] | xi[xi[i+  14]]
        & xi[xi[i+  16]] | xi[xi[i+  18]]
        & xi[xi[i+  20]] | xi[xi[i+  22]]
        & xi[xi[i+  24]] | xi[xi[i+  26]]
        & xi[xi[i+  28]] | xi[xi[i+  30]]
        & xi[xi[i+  32]] | xi[xi[i+  34]]
        & xi[xi[i+  36]] | xi[xi[i+  38]]
        & xi[xi[i+  40]] | xi[xi[i+  42]]
        & xi[xi[i+  44]] | xi[xi[i+  46]]
        & xi[xi[i+  48]] | xi[xi[i+  50]]
        & xi[xi[i+  52]] | xi[xi[i+  54]]
        & xi[xi[i+  56]] | xi[xi[i+  58]]
        & xi[xi[i+  60]] | xi[xi[i+  62]]
        & xi[xi[i+  64]] | xi[xi[i+  66]]
        & xi[xi[i+  68]] | xi[xi[i+  70]]
        & xi[xi[i+  72]] | xi[xi[i+  74]]
        & xi[xi[i+  76]] | xi[xi[i+  78]]
        & xi[xi[i+  80]] | xi[xi[i+  82]]
        & xi[xi[i+  84]] | xi[xi[i+  86]]
        & xi[xi[i+  88]] | xi[xi[i+  90]]
        & xi[xi[i+  92]] | xi[xi[i+  94]]
        & xi[xi[i+  96]] | xi[xi[i+  98]]
        & xi[xi[i+ 100]] | xi[xi[i+ 102]]
        & xi[xi[i+ 104]] | xi[xi[i+ 106]]
        & xi[xi[i+ 108]] | xi[xi[i+ 110]]
        & xi[xi[i+ 112]] | xi[xi[i+ 114]]
        & xi[xi[i+ 116]] | xi[xi[i+ 118]]
        & xi[xi[i+ 120]] | xi[xi[i+ 122]]
        & xi[xi[i+ 124]] | xi[xi[i+ 126]]
        & xi[xi[i+ 128]] | xi[xi[i+ 130]]
        & xi[xi[i+ 132]] | xi[xi[i+ 134]]
        & xi[xi[i+ 136]] | xi[xi[i+ 138]]
        & xi[xi[i+ 140]] | xi[xi[i+ 142]]
        & xi[xi[i+ 144]] | xi[xi[i+ 146]]
        & xi[xi[i+ 148]] | xi[xi[i+ 150]]
        & xi[xi[i+ 152]] | xi[xi[i+ 154]]
        & xi[xi[i+ 156]] | xi[xi[i+ 158]]
        & xi[xi[i+ 160]] | xi[xi[i+ 162]]
        & xi[xi[i+ 164]] | xi[xi[i+ 166]]
        & xi[xi[i+ 168]] | xi[xi[i+ 170]]
        & xi[xi[i+ 172]] | xi[xi[i+ 174]]
        & xi[xi[i+ 176]] | xi[xi[i+ 178]]
        & xi[xi[i+ 180]] | xi[xi[i+ 182]]
        & xi[xi[i+ 184]] | xi[xi[i+ 186]]
        & xi[xi[i+ 188]] | xi[xi[i+ 190]]
        & xi[xi[i+ 192]] | xi[xi[i+ 194]]
        & xi[xi[i+ 196]] | xi[xi[i+ 198]]
        & xi[xi[i+ 200]] | xi[xi[i+ 202]]
        & xi[xi[i+ 204]] | xi[xi[i+ 206]]
        & xi[xi[i+ 208]] | xi[xi[i+ 210]]
        & xi[xi[i+ 212]] | xi[xi[i+ 214]]
        & xi[xi[i+ 216]] | xi[xi[i+ 218]]
        & xi[xi[i+ 220]] | xi[xi[i+ 222]]
        & xi[xi[i+ 224]] | xi[xi[i+ 226]]
        & xi[xi[i+ 228]] | xi[xi[i+ 230]]
        & xi[xi[i+ 232]] | xi[xi[i+ 234]]
        & xi[xi[i+ 236]] | xi[xi[i+ 238]]
        & xi[xi[i+ 240]] | xi[xi[i+ 242]]
        & xi[xi[i+ 244]] | xi[xi[i+ 246]]
        & xi[xi[i+ 248]] | xi[xi[i+ 250]]
        & xi[xi[i+ 252]] | xi[xi[i+ 254]];
    }
  }
  return;
}

void thread1TestRW()    
{
  int i, j;

  for (j=0; j<extraLoops; j++)
  {
    for (i=startWords; i<endWords; i = i + 512)
    {
         xi[xi[i+   0]] = xi[xi[i+   2]];
         xi[xi[i+   4]] = xi[xi[i+   6]];
         xi[xi[i+   8]] = xi[xi[i+  10]];
         xi[xi[i+  12]] = xi[xi[i+  14]];
         xi[xi[i+  16]] = xi[xi[i+  18]];
         xi[xi[i+  20]] = xi[xi[i+  22]];
         xi[xi[i+  24]] = xi[xi[i+  26]];
         xi[xi[i+  28]] = xi[xi[i+  30]];
         xi[xi[i+  32]] = xi[xi[i+  34]];
         xi[xi[i+  36]] = xi[xi[i+  38]];
         xi[xi[i+  40]] = xi[xi[i+  42]];
         xi[xi[i+  44]] = xi[xi[i+  46]];
         xi[xi[i+  48]] = xi[xi[i+  50]];
         xi[xi[i+  52]] = xi[xi[i+  54]];
         xi[xi[i+  56]] = xi[xi[i+  58]];
         xi[xi[i+  60]] = xi[xi[i+  62]];
         xi[xi[i+  64]] = xi[xi[i+  66]];
         xi[xi[i+  68]] = xi[xi[i+  70]];
         xi[xi[i+  72]] = xi[xi[i+  74]];
         xi[xi[i+  76]] = xi[xi[i+  78]];
         xi[xi[i+  80]] = xi[xi[i+  82]];
         xi[xi[i+  84]] = xi[xi[i+  86]];
         xi[xi[i+  88]] = xi[xi[i+  90]];
         xi[xi[i+  92]] = xi[xi[i+  94]];
         xi[xi[i+  96]] = xi[xi[i+  98]];
         xi[xi[i+ 100]] = xi[xi[i+ 102]];
         xi[xi[i+ 104]] = xi[xi[i+ 106]];
         xi[xi[i+ 108]] = xi[xi[i+ 110]];
         xi[xi[i+ 112]] = xi[xi[i+ 114]];
         xi[xi[i+ 116]] = xi[xi[i+ 118]];
         xi[xi[i+ 120]] = xi[xi[i+ 122]];
         xi[xi[i+ 124]] = xi[xi[i+ 126]];
         xi[xi[i+ 128]] = xi[xi[i+ 130]];
         xi[xi[i+ 132]] = xi[xi[i+ 134]];
         xi[xi[i+ 136]] = xi[xi[i+ 138]];
         xi[xi[i+ 140]] = xi[xi[i+ 142]];
         xi[xi[i+ 144]] = xi[xi[i+ 146]];
         xi[xi[i+ 148]] = xi[xi[i+ 150]];
         xi[xi[i+ 152]] = xi[xi[i+ 154]];
         xi[xi[i+ 156]] = xi[xi[i+ 158]];
         xi[xi[i+ 160]] = xi[xi[i+ 162]];
         xi[xi[i+ 164]] = xi[xi[i+ 166]];
         xi[xi[i+ 168]] = xi[xi[i+ 170]];
         xi[xi[i+ 172]] = xi[xi[i+ 174]];
         xi[xi[i+ 176]] = xi[xi[i+ 178]];
         xi[xi[i+ 180]] = xi[xi[i+ 182]];
         xi[xi[i+ 184]] = xi[xi[i+ 186]];
         xi[xi[i+ 188]] = xi[xi[i+ 190]];
         xi[xi[i+ 192]] = xi[xi[i+ 194]];
         xi[xi[i+ 196]] = xi[xi[i+ 198]];
         xi[xi[i+ 200]] = xi[xi[i+ 202]];
         xi[xi[i+ 204]] = xi[xi[i+ 206]];
         xi[xi[i+ 208]] = xi[xi[i+ 210]];
         xi[xi[i+ 212]] = xi[xi[i+ 214]];
         xi[xi[i+ 216]] = xi[xi[i+ 218]];
         xi[xi[i+ 220]] = xi[xi[i+ 222]];
         xi[xi[i+ 224]] = xi[xi[i+ 226]];
         xi[xi[i+ 228]] = xi[xi[i+ 230]];
         xi[xi[i+ 232]] = xi[xi[i+ 234]];
         xi[xi[i+ 236]] = xi[xi[i+ 238]];
         xi[xi[i+ 240]] = xi[xi[i+ 242]];
         xi[xi[i+ 244]] = xi[xi[i+ 246]];
         xi[xi[i+ 248]] = xi[xi[i+ 250]];
         xi[xi[i+ 252]] = xi[xi[i+ 254]];
         xi[xi[i+ 256]] = xi[xi[i+ 258]];
         xi[xi[i+ 260]] = xi[xi[i+ 262]];
         xi[xi[i+ 264]] = xi[xi[i+ 266]];
         xi[xi[i+ 268]] = xi[xi[i+ 270]];
         xi[xi[i+ 272]] = xi[xi[i+ 274]];
         xi[xi[i+ 276]] = xi[xi[i+ 278]];
         xi[xi[i+ 280]] = xi[xi[i+ 282]];
         xi[xi[i+ 284]] = xi[xi[i+ 286]];
         xi[xi[i+ 288]] = xi[xi[i+ 290]];
         xi[xi[i+ 292]] = xi[xi[i+ 294]];
         xi[xi[i+ 296]] = xi[xi[i+ 298]];
         xi[xi[i+ 300]] = xi[xi[i+ 302]];
         xi[xi[i+ 304]] = xi[xi[i+ 306]];
         xi[xi[i+ 308]] = xi[xi[i+ 310]];
         xi[xi[i+ 312]] = xi[xi[i+ 314]];
         xi[xi[i+ 316]] = xi[xi[i+ 318]];
         xi[xi[i+ 320]] = xi[xi[i+ 322]];
         xi[xi[i+ 324]] = xi[xi[i+ 326]];
         xi[xi[i+ 328]] = xi[xi[i+ 330]];
         xi[xi[i+ 332]] = xi[xi[i+ 334]];
         xi[xi[i+ 336]] = xi[xi[i+ 338]];
         xi[xi[i+ 340]] = xi[xi[i+ 342]];
         xi[xi[i+ 344]] = xi[xi[i+ 346]];
         xi[xi[i+ 348]] = xi[xi[i+ 350]];
         xi[xi[i+ 352]] = xi[xi[i+ 354]];
         xi[xi[i+ 356]] = xi[xi[i+ 358]];
         xi[xi[i+ 360]] = xi[xi[i+ 362]];
         xi[xi[i+ 364]] = xi[xi[i+ 366]];
         xi[xi[i+ 368]] = xi[xi[i+ 370]];
         xi[xi[i+ 372]] = xi[xi[i+ 374]];
         xi[xi[i+ 376]] = xi[xi[i+ 378]];
         xi[xi[i+ 380]] = xi[xi[i+ 382]];
         xi[xi[i+ 384]] = xi[xi[i+ 386]];
         xi[xi[i+ 388]] = xi[xi[i+ 390]];
         xi[xi[i+ 392]] = xi[xi[i+ 394]];
         xi[xi[i+ 396]] = xi[xi[i+ 398]];
         xi[xi[i+ 400]] = xi[xi[i+ 402]];
         xi[xi[i+ 404]] = xi[xi[i+ 406]];
         xi[xi[i+ 408]] = xi[xi[i+ 410]];
         xi[xi[i+ 412]] = xi[xi[i+ 414]];
         xi[xi[i+ 416]] = xi[xi[i+ 418]];
         xi[xi[i+ 420]] = xi[xi[i+ 422]];
         xi[xi[i+ 424]] = xi[xi[i+ 426]];
         xi[xi[i+ 428]] = xi[xi[i+ 430]];
         xi[xi[i+ 432]] = xi[xi[i+ 434]];
         xi[xi[i+ 436]] = xi[xi[i+ 438]];
         xi[xi[i+ 440]] = xi[xi[i+ 442]];
         xi[xi[i+ 444]] = xi[xi[i+ 446]];
         xi[xi[i+ 448]] = xi[xi[i+ 450]];
         xi[xi[i+ 452]] = xi[xi[i+ 454]];
         xi[xi[i+ 456]] = xi[xi[i+ 458]];
         xi[xi[i+ 460]] = xi[xi[i+ 462]];
         xi[xi[i+ 464]] = xi[xi[i+ 466]];
         xi[xi[i+ 468]] = xi[xi[i+ 470]];
         xi[xi[i+ 472]] = xi[xi[i+ 474]];
         xi[xi[i+ 476]] = xi[xi[i+ 478]];
         xi[xi[i+ 480]] = xi[xi[i+ 482]];
         xi[xi[i+ 484]] = xi[xi[i+ 486]];
         xi[xi[i+ 488]] = xi[xi[i+ 490]];
         xi[xi[i+ 492]] = xi[xi[i+ 494]];
         xi[xi[i+ 496]] = xi[xi[i+ 498]];
         xi[xi[i+ 500]] = xi[xi[i+ 502]];
         xi[xi[i+ 504]] = xi[xi[i+ 506]];
         xi[xi[i+ 508]] = xi[xi[i+ 510]];
    }
  }
    return;
}

void thread2TestRW()    
{
  int i, j;

  for (j=0; j<extraLoops2; j++)
  {
    for (i=startWords2; i<endWords2; i = i + 512)
    {
         xi[xi[i+ 256]] = xi[xi[i+ 258]];
         xi[xi[i+ 260]] = xi[xi[i+ 262]];
         xi[xi[i+ 264]] = xi[xi[i+ 266]];
         xi[xi[i+ 268]] = xi[xi[i+ 270]];
         xi[xi[i+ 272]] = xi[xi[i+ 274]];
         xi[xi[i+ 276]] = xi[xi[i+ 278]];
         xi[xi[i+ 280]] = xi[xi[i+ 282]];
         xi[xi[i+ 284]] = xi[xi[i+ 286]];
         xi[xi[i+ 288]] = xi[xi[i+ 290]];
         xi[xi[i+ 292]] = xi[xi[i+ 294]];
         xi[xi[i+ 296]] = xi[xi[i+ 298]];
         xi[xi[i+ 300]] = xi[xi[i+ 302]];
         xi[xi[i+ 304]] = xi[xi[i+ 306]];
         xi[xi[i+ 308]] = xi[xi[i+ 310]];
         xi[xi[i+ 312]] = xi[xi[i+ 314]];
         xi[xi[i+ 316]] = xi[xi[i+ 318]];
         xi[xi[i+ 320]] = xi[xi[i+ 322]];
         xi[xi[i+ 324]] = xi[xi[i+ 326]];
         xi[xi[i+ 328]] = xi[xi[i+ 330]];
         xi[xi[i+ 332]] = xi[xi[i+ 334]];
         xi[xi[i+ 336]] = xi[xi[i+ 338]];
         xi[xi[i+ 340]] = xi[xi[i+ 342]];
         xi[xi[i+ 344]] = xi[xi[i+ 346]];
         xi[xi[i+ 348]] = xi[xi[i+ 350]];
         xi[xi[i+ 352]] = xi[xi[i+ 354]];
         xi[xi[i+ 356]] = xi[xi[i+ 358]];
         xi[xi[i+ 360]] = xi[xi[i+ 362]];
         xi[xi[i+ 364]] = xi[xi[i+ 366]];
         xi[xi[i+ 368]] = xi[xi[i+ 370]];
         xi[xi[i+ 372]] = xi[xi[i+ 374]];
         xi[xi[i+ 376]] = xi[xi[i+ 378]];
         xi[xi[i+ 380]] = xi[xi[i+ 382]];
         xi[xi[i+ 384]] = xi[xi[i+ 386]];
         xi[xi[i+ 388]] = xi[xi[i+ 390]];
         xi[xi[i+ 392]] = xi[xi[i+ 394]];
         xi[xi[i+ 396]] = xi[xi[i+ 398]];
         xi[xi[i+ 400]] = xi[xi[i+ 402]];
         xi[xi[i+ 404]] = xi[xi[i+ 406]];
         xi[xi[i+ 408]] = xi[xi[i+ 410]];
         xi[xi[i+ 412]] = xi[xi[i+ 414]];
         xi[xi[i+ 416]] = xi[xi[i+ 418]];
         xi[xi[i+ 420]] = xi[xi[i+ 422]];
         xi[xi[i+ 424]] = xi[xi[i+ 426]];
         xi[xi[i+ 428]] = xi[xi[i+ 430]];
         xi[xi[i+ 432]] = xi[xi[i+ 434]];
         xi[xi[i+ 436]] = xi[xi[i+ 438]];
         xi[xi[i+ 440]] = xi[xi[i+ 442]];
         xi[xi[i+ 444]] = xi[xi[i+ 446]];
         xi[xi[i+ 448]] = xi[xi[i+ 450]];
         xi[xi[i+ 452]] = xi[xi[i+ 454]];
         xi[xi[i+ 456]] = xi[xi[i+ 458]];
         xi[xi[i+ 460]] = xi[xi[i+ 462]];
         xi[xi[i+ 464]] = xi[xi[i+ 466]];
         xi[xi[i+ 468]] = xi[xi[i+ 470]];
         xi[xi[i+ 472]] = xi[xi[i+ 474]];
         xi[xi[i+ 476]] = xi[xi[i+ 478]];
         xi[xi[i+ 480]] = xi[xi[i+ 482]];
         xi[xi[i+ 484]] = xi[xi[i+ 486]];
         xi[xi[i+ 488]] = xi[xi[i+ 490]];
         xi[xi[i+ 492]] = xi[xi[i+ 494]];
         xi[xi[i+ 496]] = xi[xi[i+ 498]];
         xi[xi[i+ 500]] = xi[xi[i+ 502]];
         xi[xi[i+ 504]] = xi[xi[i+ 506]];
         xi[xi[i+ 508]] = xi[xi[i+ 510]];
         xi[xi[i+   0]] = xi[xi[i+   2]];
         xi[xi[i+   4]] = xi[xi[i+   6]];
         xi[xi[i+   8]] = xi[xi[i+  10]];
         xi[xi[i+  12]] = xi[xi[i+  14]];
         xi[xi[i+  16]] = xi[xi[i+  18]];
         xi[xi[i+  20]] = xi[xi[i+  22]];
         xi[xi[i+  24]] = xi[xi[i+  26]];
         xi[xi[i+  28]] = xi[xi[i+  30]];
         xi[xi[i+  32]] = xi[xi[i+  34]];
         xi[xi[i+  36]] = xi[xi[i+  38]];
         xi[xi[i+  40]] = xi[xi[i+  42]];
         xi[xi[i+  44]] = xi[xi[i+  46]];
         xi[xi[i+  48]] = xi[xi[i+  50]];
         xi[xi[i+  52]] = xi[xi[i+  54]];
         xi[xi[i+  56]] = xi[xi[i+  58]];
         xi[xi[i+  60]] = xi[xi[i+  62]];
         xi[xi[i+  64]] = xi[xi[i+  66]];
         xi[xi[i+  68]] = xi[xi[i+  70]];
         xi[xi[i+  72]] = xi[xi[i+  74]];
         xi[xi[i+  76]] = xi[xi[i+  78]];
         xi[xi[i+  80]] = xi[xi[i+  82]];
         xi[xi[i+  84]] = xi[xi[i+  86]];
         xi[xi[i+  88]] = xi[xi[i+  90]];
         xi[xi[i+  92]] = xi[xi[i+  94]];
         xi[xi[i+  96]] = xi[xi[i+  98]];
         xi[xi[i+ 100]] = xi[xi[i+ 102]];
         xi[xi[i+ 104]] = xi[xi[i+ 106]];
         xi[xi[i+ 108]] = xi[xi[i+ 110]];
         xi[xi[i+ 112]] = xi[xi[i+ 114]];
         xi[xi[i+ 116]] = xi[xi[i+ 118]];
         xi[xi[i+ 120]] = xi[xi[i+ 122]];
         xi[xi[i+ 124]] = xi[xi[i+ 126]];
         xi[xi[i+ 128]] = xi[xi[i+ 130]];
         xi[xi[i+ 132]] = xi[xi[i+ 134]];
         xi[xi[i+ 136]] = xi[xi[i+ 138]];
         xi[xi[i+ 140]] = xi[xi[i+ 142]];
         xi[xi[i+ 144]] = xi[xi[i+ 146]];
         xi[xi[i+ 148]] = xi[xi[i+ 150]];
         xi[xi[i+ 152]] = xi[xi[i+ 154]];
         xi[xi[i+ 156]] = xi[xi[i+ 158]];
         xi[xi[i+ 160]] = xi[xi[i+ 162]];
         xi[xi[i+ 164]] = xi[xi[i+ 166]];
         xi[xi[i+ 168]] = xi[xi[i+ 170]];
         xi[xi[i+ 172]] = xi[xi[i+ 174]];
         xi[xi[i+ 176]] = xi[xi[i+ 178]];
         xi[xi[i+ 180]] = xi[xi[i+ 182]];
         xi[xi[i+ 184]] = xi[xi[i+ 186]];
         xi[xi[i+ 188]] = xi[xi[i+ 190]];
         xi[xi[i+ 192]] = xi[xi[i+ 194]];
         xi[xi[i+ 196]] = xi[xi[i+ 198]];
         xi[xi[i+ 200]] = xi[xi[i+ 202]];
         xi[xi[i+ 204]] = xi[xi[i+ 206]];
         xi[xi[i+ 208]] = xi[xi[i+ 210]];
         xi[xi[i+ 212]] = xi[xi[i+ 214]];
         xi[xi[i+ 216]] = xi[xi[i+ 218]];
         xi[xi[i+ 220]] = xi[xi[i+ 222]];
         xi[xi[i+ 224]] = xi[xi[i+ 226]];
         xi[xi[i+ 228]] = xi[xi[i+ 230]];
         xi[xi[i+ 232]] = xi[xi[i+ 234]];
         xi[xi[i+ 236]] = xi[xi[i+ 238]];
         xi[xi[i+ 240]] = xi[xi[i+ 242]];
         xi[xi[i+ 244]] = xi[xi[i+ 246]];
         xi[xi[i+ 248]] = xi[xi[i+ 250]];
         xi[xi[i+ 252]] = xi[xi[i+ 254]];
    }
  }
  return;
}

BOOL runTests()
{
    int i, j, k;
    double million = 1000000.0;
    double secsmm;
    FILE    *outfile;

    outfile = fopen("RandMem.txt","a+");
    if (outfile == NULL)
    {
        sprintf(writeMsg, "Cannot open results file");
        if (!autoRun) MessageBox(NULL, writeMsg, "ERROR WILL EXIT", MB_ICONWARNING | MB_OK);
        CleanUpAndPostQuit();
        return FALSE;
    }

    local_time();

    fprintf (outfile, "\n #####################################################################\n");
    fprintf(outfile, "  RandMP Write/Read Test %s %s \n", version, timeday);
    fprintf(outfile, "%s\n\n", compiler);
    fprintf(outfile, " The program uses the same code for serial and random use via a complex\n");
    fprintf(outfile, " indexing structure and comprises Read (RD) and Read/Write (RW) tests.\n");
    fprintf(outfile, " They are run to use data from L1 cache, L2 cache and RAM, firstly as a\n");
    fprintf(outfile, " single thread and secondly using two threads.\n\n");

    fprintf(outfile, "                     Copyright (C) 2005, Roy Longbottom\n\n");

    fprintf(outfile, "               ------------------ MBytes Per Second At --------------------\n");
    fprintf(outfile, "               6 KB   24 KB   96 KB  384 KB  768 KB 1536 KB   12 MB   96 MB\n");
        //               12345678 1234567 1234567 1234567 1234567 1234567 1234567 1234567 1234567
    fprintf(outfile, " 1 Thread\n");
    fflush(outfile);

    memoryBytes[0] = 1024 * 6;  // 1536 32 bit words
    memoryBytes[1] = 1024 * 24;
    memoryBytes[2] = 1024 * 96;
    memoryBytes[3] = 1024 * 384;
    memoryBytes[4] = 1024 * 768;
    memoryBytes[5] = 1024 * 1536;
    memoryBytes[6] = 1024 * 12288;
    memoryBytes[7] = 1024 * 98304; 

    ipass = 8;
    if (ramsize < 192) ipass = 7;
    if (ramsize < 32 ) ipass = 6;
    for (i=0; i<ipass; i++)
    {
        memoryWords[i]  = memoryBytes[i] / wordBytes;
    }

    xi = (int *)_aligned_malloc(memoryBytes[ipass-1] + 16, 16);
    if (xi == NULL)
    {
        sprintf(writeMsg, " Cannot allocate memory");
        if (!autoRun) MessageBox(NULL, writeMsg, " ERROR WILL EXIT", MB_ICONWARNING | MB_OK);
        fprintf(outfile," Cannot allocate memory\n\n");
        fflush(outfile);
        fclose(outfile);
        CleanUpAndPostQuit();
        return FALSE;
    }        
    timeBeginPeriod(1);                    
    runDone = TRUE;
    testRun = 0;
    extraRun = 0;
    for (k=0; k<10; k++)
    {
        for (i=0; i<15; i++)
        {
            results[k][i] = 0;
            runmsecs[k][i] = 0;
        }
    }

    // Serial Read Integer *********************

    testRun = 1;
    extraRun = 1;
    sprintf(dlgMsg1[testRun - 1], " Ser RD");
    sprintf(mslabel[testRun - 1], " Serial RD ");
    fprintf(outfile, " Serial RD ");
    for (i=0; i<ipass; i++)
    {
        for (k=0; k<memoryWords[i]+1; k++)
        {
            xi[k] = k+1;
        }
        toti1 = 12345;

        readWrite = FALSE;
        calibrate(i);
        theseWordsSR[i] = theseWords;
        startWordsSR[i] = startWords;
        endWordsSR[i]   = endWords;
        incWordsSR[i]   = incWords;
        extraLoopsSR[i] = extraLoops;
            
        threadCount1 = 0;
        mmtime0 = timeGetTime();
        start_time();
        do
        {
            thread1TestRD();
            threadCount1 = threadCount1 + 1;
            startWords = startWords + incWords;
            endWords = endWords + incWords;
            if (startWords  >= memoryWords[i])
            {
                startWords = 0;
                endWords = incWords;
            }
            end_time();            
        }
        while (secs < runSecs);
        mmtime1 = timeGetTime() - mmtime0;
        secsmm = (double)mmtime1 / 1000;
        if (secsmm / secs < 0.9 || secs / secsmm < 0.9) debug = TRUE;
        tCountSR[i] = threadCount1;
        wordsTested = (double)threadCount1 * (double)theseWords * (double)extraLoops;
        if (toti1 == 0) toti1 = 1;
        
        results[i][testRun - 1] = wordsTested * (double)wordBytes / million / secs;
        runmsecs[i][testRun - 1] = secs * 1000;
        mmmsecs[i][testRun - 1] = mmtime1;
        sprintf(addMsg, "%c%8.0f", 9, results[i][testRun - 1]);
        strcat(dlgMsg1[testRun - 1], addMsg);
        fprintf(outfile, "%8.0f", results[i][testRun - 1]);
               
        if (runHwnd)    DestroyWindow(runHwnd);
        runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            _aligned_free(xi);
            fprintf(outfile, "\n\n\n");
            fflush(outfile);
            fclose(outfile);
            timeEndPeriod(1);
            CleanUpAndPostQuit();
            return FALSE;
        }
    }
    fprintf(outfile, "\n");
    fflush(outfile);
    if (runHwnd)    DestroyWindow(runHwnd);
    runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);
    Sleep(500);

    // Serial Read/Write Integer *********************

    testRun = 2;
    extraRun = 2;
    sprintf(dlgMsg1[testRun - 1], " Ser RW");
    sprintf(mslabel[testRun - 1], " Serial WR ");    
    fprintf(outfile, " Serial RW ");
    for (i=0; i<ipass; i++)
    {
        for (k=0; k<memoryWords[i]+1; k++)
        {
            xi[k] = k+1;
        }
        toti1 = 12345;

        readWrite = TRUE;
        calibrate(i);
        theseWordsSW[i] = theseWords;
        startWordsSW[i] = startWords;
        endWordsSW[i]   = endWords;
        incWordsSW[i]   = incWords;
        extraLoopsSW[i] = extraLoops;
            
        threadCount1 = 0;
        mmtime0 = timeGetTime();
        start_time();
        do
        {
            thread1TestRW();
            threadCount1 = threadCount1 + 1;
            startWords = startWords + incWords;
            endWords = endWords + incWords;
            if (startWords  >= memoryWords[i])
            {
                startWords = 0;
                endWords = incWords;
            }
            end_time();            
        }
        while (secs < runSecs);
        mmtime1 = timeGetTime() - mmtime0;
        secsmm = (double)mmtime1 / 1000;
        if (secsmm / secs < 0.9 || secs / secsmm < 0.9) debug = TRUE;
        tCountSW[i] = threadCount1;
        wordsTested = (double)threadCount1 * (double)theseWords * (double)extraLoops;
        if (toti1 == 0) toti1 = 1;
        
        results[i][testRun - 1] = wordsTested * (double)wordBytes / million / secs;
        runmsecs[i][testRun - 1] = secs * 1000;
        mmmsecs[i][testRun - 1] = mmtime1;
        sprintf(addMsg, "%c%8.0f", 9, results[i][testRun - 1]);
        strcat(dlgMsg1[testRun - 1], addMsg);

        fprintf(outfile, "%8.0f", results[i][testRun - 1]);
               
        if (runHwnd)    DestroyWindow(runHwnd);
        runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            _aligned_free(xi);
            fprintf(outfile, "\n\n\n");
            fflush(outfile);
            fclose(outfile);
            timeEndPeriod(1);
            CleanUpAndPostQuit();
            return FALSE;
        }
    }
    fprintf(outfile, "\n");
    fflush(outfile);
    if (runHwnd)    DestroyWindow(runHwnd);
    runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);
    Sleep(500);

    // Random Read Integer *********************

    testRun = 3;
    extraRun = 3;
    sprintf(dlgMsg1[testRun - 1], " Ran RD");
    sprintf(mslabel[testRun - 1], " Random RD ");
    fprintf(outfile, " Random RD ");
    for (i=0; i<ipass; i++)
    {
        srand(123);

        for (k=0; k<memoryWords[i]+1; k++)
        {
            xi[k] = (int)((double)memoryWords[i] * ((double)(rand() * 32768 + rand()) / 32768 / 32768));
        }
        toti1 = 12345;

        readWrite = FALSE;
        calibrate(i);
        theseWordsRR[i] = theseWords;
        startWordsRR[i] = startWords;
        endWordsRR[i]   = endWords;
        incWordsRR[i]   = incWords;
        extraLoopsRR[i] = extraLoops;

        threadCount1 = 0;
        mmtime0 = timeGetTime();
        start_time();
        do
        {
            thread1TestRD();
            threadCount1 = threadCount1 + 1;
            startWords = startWords + incWords;
            endWords = endWords + incWords;
            if (startWords  >= memoryWords[i])
            {
                startWords = 0;
                endWords = incWords;
            }
            end_time();           
        }
        while (secs < runSecs);
        tCountRR[i] = threadCount1;
        mmtime1 = timeGetTime() - mmtime0;
        secsmm = (double)mmtime1 / 1000;
        if (secsmm / secs < 0.9 || secs / secsmm < 0.9) debug = TRUE;
        wordsTested = (double)threadCount1 * (double) theseWords * (double)extraLoops; // 1536;
        if (toti1 == 0) toti1 = 1;
        
        results[i][testRun - 1] = wordsTested * (double)wordBytes / million / secs;
        runmsecs[i][testRun - 1] = secs * 1000;
        mmmsecs[i][testRun - 1] = mmtime1;
        sprintf(addMsg, "%c%8.0f", 9, results[i][testRun - 1]);
        strcat(dlgMsg1[testRun - 1], addMsg);

        fprintf(outfile, "%8.0f", results[i][testRun - 1]);
               
        if (runHwnd)    DestroyWindow(runHwnd);
        runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            _aligned_free(xi);
            fprintf(outfile, "\n\n\n");
            fflush(outfile);
            fclose(outfile);
            timeEndPeriod(1);
            CleanUpAndPostQuit();
            return FALSE;
        }
    }
    fprintf(outfile, "\n");

    fflush(outfile);

    if (runHwnd)    DestroyWindow(runHwnd);
    runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);
    Sleep(500);


    // Random Read/Write Integer *********************

    testRun = 4;
    extraRun = 4;
    sprintf(dlgMsg1[testRun - 1], " Ran RW");
    sprintf(mslabel[testRun - 1], " Random RW ");
    fprintf(outfile, " Random RW ");
    for (i=0; i<ipass; i++)
    {
        srand(123);

        for (k=0; k<memoryWords[i]+1; k++)
        {
            xi[k] = (int)((double)memoryWords[i] * ((double)(rand() * 32768 + rand()) / 32768 / 32768));
        }
        toti1 = 12345;

        readWrite = TRUE;
        calibrate(i);
        theseWordsRW[i] = theseWords;
        startWordsRW[i] = startWords;
        endWordsRW[i]   = endWords;
        incWordsRW[i]   = incWords;
        extraLoopsRW[i] = extraLoops;

        threadCount1 = 0;
        mmtime0 = timeGetTime();
        start_time();
        do
        {
            thread1TestRW();
            threadCount1 = threadCount1 + 1;
            startWords = startWords + incWords;
            endWords = endWords + incWords;
            if (startWords  >= memoryWords[i])
            {
                startWords = 0;
                endWords = incWords;
            }
            end_time();           
        }
        while (secs < runSecs);
        mmtime1 = timeGetTime() - mmtime0;
        secsmm = (double)mmtime1 / 1000;
        if (secsmm / secs < 0.9 || secs / secsmm < 0.9) debug = TRUE;
        tCountRW[i] = threadCount1;
        wordsTested = (double)threadCount1 * (double) theseWords * (double)extraLoops; // 1536;
        if (toti1 == 0) toti1 = 1;
        
        results[i][testRun - 1] = wordsTested * (double)wordBytes / million / secs;
        runmsecs[i][testRun - 1] = secs * 1000;
        mmmsecs[i][testRun - 1] = mmtime1;
        sprintf(addMsg, "%c%8.0f", 9, results[i][testRun - 1]);
        strcat(dlgMsg1[testRun - 1], addMsg);

        fprintf(outfile, "%8.0f", results[i][testRun - 1]);
               
        if (runHwnd)    DestroyWindow(runHwnd);
        runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            _aligned_free(xi);
            fprintf(outfile, "\n\n\n");
            fflush(outfile);
            fclose(outfile);
            timeEndPeriod(1);
            CleanUpAndPostQuit();
            return FALSE;
        }
    }
    fprintf(outfile, "\n");
    fprintf(outfile, "\n");

    fflush(outfile);

    if (runHwnd)    DestroyWindow(runHwnd);
    runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);
    Sleep(500);

    fprintf(outfile, " 2 Threads\n");

    // Serial Read Integer 2 Threads *********************

    testRun = 5;
    extraRun = 5;
    readWrite = FALSE;
    sprintf(dlgMsg1[extraRun - 1], " Ser RD");
    sprintf(mslabel[testRun - 1], " Serial RD1");
    sprintf(mslabel[testRun],     " Serial RD2");
    fprintf(outfile, " Serial RD1");
    for (i=0; i<ipass; i++)
    {
        for (k=0; k<memoryWords[i]+1; k++)
        {
            xi[k] = k+1;
        }
        toti1 = 12345;
        toti2 = 23456;

        theseWords = theseWordsSR[i];
        startWords = startWordsSR[i];
        endWords   = endWordsSR[i];
        incWords   = incWordsSR[i];
        extraLoops = extraLoopsSR[i];
        threadCount1 = tCountSR[i];


        theseWords2 = theseWordsSR[i];
        startWords2 = startWordsSR[i];
        endWords2   = endWordsSR[i];
        incWords2   = incWordsSR[i];
        extraLoops2 = extraLoopsSR[i];
        threadCount2 = tCountSR[i];

        memoryWdsi  = memoryWords[i];

        hSema1 = CreateSemaphore(NULL, 0, 100, NULL);
        hSema2 = CreateSemaphore(NULL, 0, 100, NULL);
        hThreadHandle1 = CreateThread(NULL, 0, threadTest1RD, inputParam1, 0, &dwThreadId1);
        hThreadHandle2 = CreateThread(NULL, 0, threadTest2RD, inputParam2, 0, &dwThreadId2);
        SetThreadPriority(hThreadHandle1, THREAD_PRIORITY_NORMAL);
        SetThreadPriority(hThreadHandle2, THREAD_PRIORITY_NORMAL);
    
        mmtime0 = timeGetTime();
        start_time();
        ReleaseSemaphore(hSema1, 1, NULL);
        ReleaseSemaphore(hSema1, 1, NULL);
        WaitForSingleObject(hSema2, 50000);
        WaitForSingleObject(hSema2, 50000);            
    
        CloseHandle( hThreadHandle2 );
        CloseHandle( hThreadHandle1 );
        CloseHandle( hSema2 );
        CloseHandle( hSema1 );

        wordsTested  = (double)threadCount1 * (double)theseWords  * (double)extraLoops;
        wordsTested2 = (double)threadCount2 * (double)theseWords2 * (double)extraLoops2;
        if (toti1 == 0) toti1 = 1;
        if (toti2 == 0) toti2 = 1;
        
        results[i][testRun - 1] = wordsTested  * (double)wordBytes / million / secs1;
        results[i][testRun]     = wordsTested2 * (double)wordBytes / million / secs2;
        runmsecs[i][testRun - 1] = secs1 * 1000;
        runmsecs[i][testRun]     = secs2 * 1000;
        mmmsecs[i][testRun - 1] = mmtime1;
        mmmsecs[i][testRun]     = mmtime2;
        secsmm = (double)mmtime1 / 1000;
        if (secsmm / secs1 < 0.9 || secs1 / secsmm < 0.9) debug = TRUE;
        secsmm = (double)mmtime2 / 1000;
        if (secsmm / secs2 < 0.9 || secs2 / secsmm < 0.9) debug = TRUE;
        sprintf(addMsg, "%c%8.0f", 9, results[i][testRun - 1] + results[i][testRun]);

        strcat(dlgMsg1[extraRun - 1], addMsg);

        fprintf(outfile, "%8.0f", results[i][testRun - 1]);
               
        if (runHwnd)    DestroyWindow(runHwnd);
        runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            _aligned_free(xi);
            fprintf(outfile, "\n\n\n");
            fflush(outfile);
            fclose(outfile);
            timeEndPeriod(1);
            CleanUpAndPostQuit();
            return FALSE;
        }
    }
    fprintf(outfile, "\n");
    fprintf(outfile, " Serial RD2");
    for (i=0; i<ipass; i++)
    {
        fprintf(outfile, "%8.0f", results[i][testRun]);
    }
    fprintf(outfile, "\n");
    fprintf(outfile, "\n");
    fflush(outfile);
    if (runHwnd)    DestroyWindow(runHwnd);
    runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);
    Sleep(500);

    // Serial Read/Write Integer 2 Threads *********************

    testRun = 7;
    extraRun = 6;
    sprintf(dlgMsg1[extraRun - 1], " Ser RW");
    sprintf(mslabel[testRun - 1], " Serial RW1");
    sprintf(mslabel[testRun],     " Serial RW2");
    fprintf(outfile, " Serial RW1");
    for (i=0; i<ipass; i++)
    {
        for (k=0; k<memoryWords[i]+1; k++)
        {
            xi[k] = k+1;
        }
        toti1 = 12345;
        toti2 = 23456;

        readWrite = TRUE;
        theseWords = theseWordsSW[i];
        startWords = startWordsSW[i];
        endWords   = endWordsSW[i];
        incWords   = incWordsSW[i];
        extraLoops = extraLoopsSW[i];
        threadCount1 = tCountSW[i];


        theseWords2 = theseWordsSW[i];
        startWords2 = startWordsSW[i];
        endWords2   = endWordsSW[i];
        incWords2   = incWordsSW[i];
        extraLoops2 = extraLoopsSW[i];
        threadCount2 = tCountSW[i];

        memoryWdsi  = memoryWords[i];

        hSema1 = CreateSemaphore(NULL, 0, 100, NULL);
        hSema2 = CreateSemaphore(NULL, 0, 100, NULL);
        hThreadHandle1 = CreateThread(NULL, 0, threadTest1RW, inputParam1, 0, &dwThreadId1);
        hThreadHandle2 = CreateThread(NULL, 0, threadTest2RW, inputParam2, 0, &dwThreadId2);
        SetThreadPriority(hThreadHandle1, THREAD_PRIORITY_NORMAL);
        SetThreadPriority(hThreadHandle2, THREAD_PRIORITY_NORMAL);
    
        mmtime0 = timeGetTime();
        start_time();
        ReleaseSemaphore(hSema1, 1, NULL);
        ReleaseSemaphore(hSema1, 1, NULL);
        WaitForSingleObject(hSema2, 50000);
        WaitForSingleObject(hSema2, 50000);            
    
        CloseHandle( hThreadHandle2 );
        CloseHandle( hThreadHandle1 );
        CloseHandle( hSema2 );
        CloseHandle( hSema1 );

        wordsTested  = (double)threadCount1 * (double)theseWords  * (double)extraLoops;
        wordsTested2 = (double)threadCount2 * (double)theseWords2 * (double)extraLoops2;
        if (toti1 == 0) toti1 = 1;
        if (toti2 == 0) toti2 = 1;
        
        results[i][testRun - 1] = wordsTested  * (double)wordBytes / million / secs1;
        results[i][testRun]     = wordsTested2 * (double)wordBytes / million / secs2;
        runmsecs[i][testRun - 1] = secs1 * 1000;
        runmsecs[i][testRun]     = secs2 * 1000;
        mmmsecs[i][testRun - 1] = mmtime1;
        mmmsecs[i][testRun]     = mmtime2;
        secsmm = (double)mmtime1 / 1000;
        if (secsmm / secs1 < 0.9 || secs1 / secsmm < 0.9) debug = TRUE;
        secsmm = (double)mmtime2 / 1000;
        if (secsmm / secs2 < 0.9 || secs2 / secsmm < 0.9) debug = TRUE;
        sprintf(addMsg, "%c%8.0f", 9, results[i][testRun - 1] + results[i][testRun]);
        strcat(dlgMsg1[extraRun - 1], addMsg);

        fprintf(outfile, "%8.0f", results[i][testRun - 1]);
               
        if (runHwnd)    DestroyWindow(runHwnd);
        runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            _aligned_free(xi);
            fprintf(outfile, "\n\n\n");
            fflush(outfile);
            fclose(outfile);
            timeEndPeriod(1);
            CleanUpAndPostQuit();
            return FALSE;
        }
    }
    fprintf(outfile, "\n");
    fprintf(outfile, " Serial RW2");
    for (i=0; i<ipass; i++)
    {
        fprintf(outfile, "%8.0f", results[i][testRun]);
    }
    fprintf(outfile, "\n");
    fprintf(outfile, "\n");
    fflush(outfile);
    if (runHwnd)    DestroyWindow(runHwnd);
    runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);
    Sleep(500);

    // Random Read Integer 2 Threads *********************

    testRun = 9;
    extraRun = 7;
    readWrite = FALSE;
    sprintf(dlgMsg1[extraRun - 1], " Ran RD");
    sprintf(mslabel[testRun - 1], " Random RD1");
    sprintf(mslabel[testRun],     " Random RD2");
    fprintf(outfile, " Random RD1");
    for (i=0; i<ipass; i++)
    {
        srand(123);

        for (k=0; k<memoryWords[i]+1; k++)
        {
            xi[k] = (int)((double)memoryWords[i] * ((double)(rand() * 32768 + rand()) / 32768 / 32768));
        }
        toti1 = 12345;
        toti2 = 23456;

        theseWords = theseWordsRR[i];
        startWords = startWordsRR[i];
        endWords   = endWordsRR[i];
        incWords   = incWordsRR[i];
        extraLoops = extraLoopsRR[i];
        threadCount1 = tCountRR[i];

        theseWords2 = theseWordsRR[i];
        startWords2 = startWordsRR[i];
        endWords2   = endWordsRR[i];
        incWords2   = incWordsRR[i];
        extraLoops2 = extraLoopsRR[i];
        threadCount2 = tCountRR[i];

        memoryWdsi  = memoryWords[i];

        hSema1 = CreateSemaphore(NULL, 0, 100, NULL);
        hSema2 = CreateSemaphore(NULL, 0, 100, NULL);
        hThreadHandle1 = CreateThread(NULL, 0, threadTest1RD, inputParam1, 0, &dwThreadId1);
        hThreadHandle2 = CreateThread(NULL, 0, threadTest2RD, inputParam2, 0, &dwThreadId2);
        SetThreadPriority(hThreadHandle1, THREAD_PRIORITY_NORMAL);
        SetThreadPriority(hThreadHandle2, THREAD_PRIORITY_NORMAL);
    
        mmtime0 = timeGetTime();
        start_time();
        ReleaseSemaphore(hSema1, 1, NULL);
        ReleaseSemaphore(hSema1, 1, NULL);
        WaitForSingleObject(hSema2, 50000);
        WaitForSingleObject(hSema2, 50000);
    
        CloseHandle( hThreadHandle2 );
        CloseHandle( hThreadHandle1 );
        CloseHandle( hSema2 );
        CloseHandle( hSema1 );

        wordsTested  = (double)threadCount1 * (double) theseWords  * (double)extraLoops;
        wordsTested2 = (double)threadCount2 * (double) theseWords2 * (double)extraLoops2;
        if (toti1 == 0) toti1 = 1;
        if (toti2 == 0) toti2 = 1;
        
        results[i][testRun - 1] = wordsTested  * (double)wordBytes / million / secs1;
        results[i][testRun]     = wordsTested2 * (double)wordBytes / million / secs2;
        runmsecs[i][testRun - 1] = secs1 * 1000;
        runmsecs[i][testRun]     = secs2 * 1000;
        mmmsecs[i][testRun - 1] = mmtime1;
        mmmsecs[i][testRun]     = mmtime2;
        secsmm = (double)mmtime1 / 1000;
        if (secsmm / secs1 < 0.9 || secs1 / secsmm < 0.9) debug = TRUE;
        secsmm = (double)mmtime2 / 1000;
        if (secsmm / secs2 < 0.9 || secs2 / secsmm < 0.9) debug = TRUE;
        sprintf(addMsg, "%c%8.0f", 9, results[i][testRun - 1] + results[i][testRun]);
        strcat(dlgMsg1[extraRun - 1], addMsg);

        fprintf(outfile, "%8.0f", results[i][testRun - 1]);
              
        if (runHwnd)    DestroyWindow(runHwnd);
        runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            _aligned_free(xi);
            fprintf(outfile, "\n\n\n");
            fflush(outfile);
            fclose(outfile);
            timeEndPeriod(1);
            CleanUpAndPostQuit();
            return FALSE;
        }
    }
    fprintf(outfile, "\n");
    fprintf(outfile, " Random RD2");
    for (i=0; i<ipass; i++)
    {
        fprintf(outfile, "%8.0f", results[i][testRun]);
    }
    fprintf(outfile, "\n");
    fprintf(outfile, "\n");
    fflush(outfile);
    if (runHwnd)    DestroyWindow(runHwnd);
    runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);
    Sleep(500);

    // Random Read/Write Integer 2 Threads *********************

    testRun = 11;
    extraRun = 8;
    sprintf(dlgMsg1[extraRun - 1], " Ran RW");
    sprintf(mslabel[testRun - 1], " Random RW1");
    sprintf(mslabel[testRun],     " Random RW2");
    fprintf(outfile, " Random RW1");
    for (i=0; i<ipass; i++)
    {
        srand(123);

        for (k=0; k<memoryWords[i]+1; k++)
        {
            xi[k] = (int)((double)memoryWords[i] * ((double)(rand() * 32768 + rand()) / 32768 / 32768));
        }
        toti1 = 12345;
        toti2 = 23456;

        readWrite = TRUE;
        theseWords = theseWordsRW[i];
        startWords = startWordsRW[i];
        endWords   = endWordsRW[i];
        incWords   = incWordsRW[i];
        extraLoops = extraLoopsRW[i];
        threadCount1 = tCountRW[i];

        theseWords2 = theseWordsRW[i];
        startWords2 = startWordsRW[i];
        endWords2   = endWordsRW[i];
        incWords2   = incWordsRW[i];
        extraLoops2 = extraLoopsRW[i];
        threadCount2 = tCountRW[i];

        memoryWdsi  = memoryWords[i];

        hSema1 = CreateSemaphore(NULL, 0, 100, NULL);
        hSema2 = CreateSemaphore(NULL, 0, 100, NULL);
        hThreadHandle1 = CreateThread(NULL, 0, threadTest1RW, inputParam1, 0, &dwThreadId1);
        hThreadHandle2 = CreateThread(NULL, 0, threadTest2RW, inputParam2, 0, &dwThreadId2);
        SetThreadPriority(hThreadHandle1, THREAD_PRIORITY_NORMAL);
        SetThreadPriority(hThreadHandle2, THREAD_PRIORITY_NORMAL);
    
        mmtime0 = timeGetTime();
        start_time();
        ReleaseSemaphore(hSema1, 1, NULL);
        ReleaseSemaphore(hSema1, 1, NULL);
        WaitForSingleObject(hSema2, 50000);
        WaitForSingleObject(hSema2, 50000);
    
        CloseHandle( hThreadHandle2 );
        CloseHandle( hThreadHandle1 );
        CloseHandle( hSema2 );
        CloseHandle( hSema1 );

        wordsTested  = (double)threadCount1 * (double) theseWords  * (double)extraLoops;
        wordsTested2 = (double)threadCount2 * (double) theseWords2 * (double)extraLoops2;
        if (toti1 == 0) toti1 = 1;
        if (toti2 == 0) toti2 = 1;
        
        results[i][testRun - 1] = wordsTested  * (double)wordBytes / million / secs1;
        results[i][testRun]     = wordsTested2 * (double)wordBytes / million / secs2;
        runmsecs[i][testRun - 1] = secs1 * 1000;
        runmsecs[i][testRun]     = secs2 * 1000;
        mmmsecs[i][testRun - 1] = mmtime1;
        mmmsecs[i][testRun]     = mmtime2;
        secsmm = (double)mmtime1 / 1000;
        if (secsmm / secs1 < 0.9 || secs1 / secsmm < 0.9) debug = TRUE;
        secsmm = (double)mmtime2 / 1000;
        if (secsmm / secs2 < 0.9 || secs2 / secsmm < 0.9) debug = TRUE;
        sprintf(addMsg, "%c%8.0f", 9, results[i][testRun - 1] + results[i][testRun]);
        strcat(dlgMsg1[extraRun - 1], addMsg);

        fprintf(outfile, "%8.0f", results[i][testRun - 1]);
              
        if (runHwnd)    DestroyWindow(runHwnd);
        runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);

        if (GetAsyncKeyState(VK_ESCAPE) != keyPress)
        {
            _aligned_free(xi);
            fprintf(outfile, "\n\n\n");
            fflush(outfile);
            fclose(outfile);
            timeEndPeriod(1);
            CleanUpAndPostQuit();
            return FALSE;
        }
    }
    fprintf(outfile, "\n");
    fprintf(outfile, " Random RW2");
    for (i=0; i<ipass; i++)
    {
        fprintf(outfile, "%8.0f", results[i][testRun]);
    }
    fprintf(outfile, "\n");
    fflush(outfile);
    if (runHwnd)    DestroyWindow(runHwnd);
    runHwnd = CreateDialog( MyInstance,"DIALOG_9", mainHWND, (DLGPROC)RunPanel);
    Sleep(500);

    getDetails();
    _aligned_free(xi);
    if (autoRun) DestroyWindow(runHwnd);
    timeEndPeriod(1);
    local_time();
    fprintf(outfile, "\n                     End of test %s\n", timeday);        
    fprintf(outfile, "%s\n\n", mips);
    for (i=0; i<9; i++)
    {
        fprintf(outfile, "%s\n", configdata[i]);
    }
    fprintf(outfile, "\n");
    if (debug)
    {
        fprintf(outfile, " Runtime Milliseconds QueryPerformanceCounter\n");
        for (j=0;  j<testRun+1; j++)
        {
            fprintf(outfile, "%s", mslabel[j]);
            for (i=0; i<ipass; i++)
            {
               fprintf(outfile, "%8.0f", runmsecs[i][j]);
            }
            fprintf(outfile, "\n");
        }
        fprintf(outfile, " Runtime Milliseconds timeGetTime\n");
        for (j=0;  j<testRun+1; j++)
        {
            fprintf(outfile, "%s", mslabel[j]);
            for (i=0; i<ipass; i++)
            {
               fprintf(outfile, "%8d", mmmsecs[i][j]);
            }
            fprintf(outfile, "\n");
        }
        fprintf(outfile, "\n");
    }
    fflush (outfile);
    fclose(outfile);
    doTesting = FALSE;
    if (!autoRun) displayWhatever(mainHWND);                                      

    return TRUE;
    
} // runTests

void calibrate(int i)
{
        int k;
        BOOL needsSegments;
        
        startWords = 0;        
        extraLoops = 1;
        needsSegments = FALSE;
        kcount = 0.0;
        incWords = 1536;
        if (i > 1) incWords = 3072;
        if (i > 2) incWords = memoryWords[i] / 16;
        if (i > 5) incWords = memoryWords[i] / 32;
        for (k=0; k<memoryWords[i]; k=k+incWords)
        {
            endWords = k + incWords;
            start_time();
            if (readWrite)
            {
                thread1TestRW();
            }
            else
            {
                thread1TestRD();
            }
            end_time();
            kcount = kcount + 1.0;
            if (secs > runSecs / 100)
            {
                needsSegments = TRUE;
                kcount = kcount * (runSecs / 100) / secs;
                if ((int)kcount > 0)
                {
                    theseWords = incWords * (int)(kcount);
                }
                else
                {
                    theseWords = endWords;
                }
                k = memoryWords[i];
            }             
        }
        if (needsSegments)
        {
            incWords = theseWords / 1536;
            theseWords = 1;
            for (k=0; k<14; k++)
            {
                if (incWords < theseWords * 2)
                {
                    incWords = theseWords;
                    k = 15;
                }
                else
                {
                    theseWords = theseWords * 2;
                }
            }
            incWords = incWords * 1536;       
            startWords = 0;
            endWords = incWords;
            theseWords = incWords;
            extraLoops = 1;            
        }
        else
        {
           startWords = 0;        
           endWords = memoryWords[i];
           theseWords = memoryWords[i];
           incWords = 0;
           extraLoops = 10;
           for (k=0; k<3; k++)
           {
               start_time();
                if (readWrite)
                {
                    thread1TestRW();
                }
                else
                {
                    thread1TestRD();
                }
               end_time();
               if (secs > runSecs / 100)
               {
                   extraLoops = (int)(runSecs / (secs / (double)extraLoops) / 100);
                   if (extraLoops < 1) extraLoops = 1;
                   k = 3;
               }
               else
               {
                   extraLoops = extraLoops * 10;
               }               
           }
           if (extraLoops > 1000) extraLoops = 1000;
        }        
}

